biomes = {
    --Biomes are:
        --Ice
        --Tundra
        --GrassLand
        --Taiga
        --Woodland
        --Desert
        --SeasonalForest
        --TropicalRainForest
        --Savanna

                    --   coldest     colder     cold          hot                   hotter                 hottest
    --[[dryest ]]     {"Ice",      "Tundra",  "Grassland",  "Desert",             "Desert",              "Desert"},
    --[[dryer  ]]     {"Ice",      "Tundra",  "Grassland",  "Desert",             "Desert",              "Desert"},
    --[[dry    ]]     {"Ice",      "Tundra",  "Woodland",   "Woodland",           "Savanna",             "Savanna"},
    --[[wet    ]]     {"Ice",      "Tundra",  "Taiga",      "Woodland",           "Savanna",             "Savanna"},
    --[[wetter ]]     {"Ice",      "Tundra",  "Taiga",      "SeasonalForest",     "TropicalRainForest",  "TropicalRainForest"},
    --[[wettest]]     {"Ice",      "Tundra",  "Taiga",      "TropicalRainForest", "TropicalRainForest",  "TropicalRainForest"}
    
}

function scaleCoords(x,y)
    return x/mapSize.value,y/mapSize.value
end

function scale(_noise)
    -- Rescale from -1.0:+1.0 to 0.0:1.0
    return _noise--/2.0+0.5
end
function _scale(_noise)
    -- Rescale from -1.0:+1.0 to 0.0:1.0
    return _noise/2.0+0.5
end

function getNoise(x,y,options)

    local options = {
        octaves = (options and options.octave) or 1,
        frequency = (options and options.frequency) or 1,
        amplitude = (options and options.amplitude) or 1,
        persistence = (options and options.persistence) or 1,
        power = (options and options.power) or 1
    }
    
    local n = 0
    local fr = options.frequency
    local oct = options.octaves
    local a = options.amplitude
    local p = options.persistence
    local pow = options.power
    
    for i = 1,oct do
        n = n+noise(x*fr,y*fr)*a
        log(n)
        fr = fr*2
        a = a*p
    end
    log(n) log(x..","..y) log(options)
    local n = math.pow(scale(n,{max=oct}),pow)
    return n
end

function loadNoise(x,y)
    h = mapSize.value
    w = mapSize.value

    values = {
        octave=octaves.value,
        frequency=frequency.value+(miniFrequency.value/100),
        amplitude=amplitude.value+(miniAmplitude.value/100),
        persistence=persistence.value+(miniPersistence.value/100),
        power=pow.value
    }
    return getNoise(x,y,values)
end

function loadMap()
    map = {}
    h = mapSize.value
    w = mapSize.value
    local sx, sy
    for x=1,60 do
        for y=1,60 do
            sx = x/w
            sy = y/h
            local t = generateTerrain(x,y)
            storeTile(t)
        end
    end
    return map
end

function love.load()
    math.randomseed(5)
    class = require 'tools/class'
    listbox = require 'tools/listbox'

    require 'tools/gooi'
    require 'tools/tools'




    Animation = require 'tools/animation'


    color = require 'tools/color'
    mlib = require 'tools/mlib'
    sti = require "tools/sti"
    rot = require "tools/src.rot"
    lume = require 'tools/lume'
    colors = color


    Paddy = require 'tools/paddy'
    JumperGrid = require "tools/jumper.grid"
    PathFinder = require "tools/jumper.pathfinder"
    Gamestate = require "tools/hump/gamestate"
    Signal = require "tools/hump/signal"
    Timer = require "tools/hump/timer"
    saveTable = require "tools/saveTable"


    Biome = require 'noise/biomes'
    mapGen = require "noise/mapGen"
    Game=require "game"
    game=Game:new()
    game:__init__()
    map = {}
    __noise=noise
    function noise(...)
        return _scale(__noise(...))
    end
    
    mapSize = gooi.newSpinner({
        value=10,
        min=0,
        max=1000
    })
    octaves = gooi.newSpinner({
        value=1,
        min=0,
        max=100
    })
    frequency = gooi.newSpinner({
        value=1,
        min=0,
        max=100
    })
    miniFrequency = gooi.newSpinner({
        value=0,
        min=0,
        max=100
    })
    amplitude = gooi.newSpinner({
        value=1,
        min=0,
        max=100
    })
    miniAmplitude = gooi.newSpinner({
        value=0,
        min=0,
        max=100
    })
    persistence = gooi.newSpinner({
        value=1,
        min=0,
        max=100
    })
    miniPersistence = gooi.newSpinner({
        value=0,
        min=0,
        max=100
    })
    pow = gooi.newSpinner({
        value=1,
        min=0,
        max=1000
    })
    editor = gooi.newPanel({x=W()-(W()/5),y=0,w=W()/5,h=H(),layout="grid 20x1"}):
    add(
        gooi.newButton({text="mapSize:"}),
        mapSize,
        gooi.newButton({text="octaves:"}),
        octaves,
        gooi.newButton({text="frequency:"}),
        frequency,
        gooi.newButton({text=".frequency:"}),
        miniFrequency,
        gooi.newButton({text="amplitude:"}),
        amplitude,
        gooi.newButton({text=".amplitude:"}),
        miniAmplitude,
        gooi.newButton({text="persistence:"}),
        persistence,
        gooi.newButton({text=".persistence:"}),
        miniPersistence,
        gooi.newButton({text="power:"}),
        pow,--[[gooi.newRadio({text="math.pow?",radioGrouo="noise"}):
             onSelected(function(y)
                if y.selected then
                    pow = true
                else
                    pow = false
                end
            end)]]
        gooi.newButton({text="getHeight"}):
            onRelease(function(y)
                reload(_G[y.text])
                _func = _G[y.text]
            end),
        gooi.newButton({text="getMoisture"}):
            onRelease(function(y)
                _func=_G[y.text]            
                reload(_G[y.text])
            end)
    )
    _func = getHeight
    setters = {octaves,frequency,amplitude,miniFrequency,miniAmplitude,persistence,miniPersistence,mapSize,pow}
    loadMap()
       
    
end
d=0
function love.update(dt)
    gooi.update(dt)
   -- if d<.5 then d=d+dt return end
    d=0
    local l = false
    for x,i in ipairs(setters) do
        if i.value ~= i.oldVal then
        
            i.oldVal = i.value
            l = true
            ii=i
        end
    end

    if l then 
        log("!"..tostring(ii)) reload(_func)
    else
        log(tostring("nope"))
    end
    update(dt)
            
end


draw = function(self)
    for x,i in lume.iter(allTiles) do
        love.graphics.draw(game:getSource(i.source),i._x,i._y,0,i._w,i._h)
       -- for _,ii in lume.iter(i.children) do
       --     ii:draw()
        --end
    end
end
update = function(self,dt)
    for x,tile in lume.iter(allTiles) do
        tile._x = tile.ttx*tile.w
        tile._y = tile.tty*tile.h
        
        tile._w,tile._h = resizeImage(game:getSource(tile.source),
            tile.w,tile.h)
     --   for _,i in lume.iter(tile.children) do
                --i:update(dt)
     --   end
    end
end

function reset()
    map = {}
    allTiles = {}
end

function love.draw()
    gooi.draw()
    for i,x in ipairs(map) do
        love.graphics.setColor({255,255,255,1*x.noise})--*x.noise
        love.graphics.rectangle("fill",x.x*16,x.y*16,16,16)
    end
    draw()
end

function love.mousepressed()
    gooi.pressed()
end        
function generateTerrain(x, y)
    --x, y are scaled
 
    __y = y
    __x = x
    local rivers = {}
    x,y = scaleCoords(x,y)

    local elevation = getHeight(x,y)
    local temperature = getTemperature(0,y,{height=elevation})--scale(noise2D(x*F,y*F)*A)
    local moisture = getMoisture(x,y,{height=elevation})--scale(love.math.noise(x*F,y*F, 0)*A)
    local tile = getBiome(elevation, temperature, moisture)
    tile.w, tile.h = _tile.w, _tile.h
    --log(lume.serialiqze(tile))
    
    tile.height = elevation
    tile.moisture = moisture
    tile.temperature = temperature
    tile.temp = tile.temperature
    
    tile.ttx=__x
    tile.tty=__y
    tile.source = "biomes/"..lume.randomchoice(tile.sources).."/"..tile.height.name..".png"
    if tile.isRiver then tile.source= "player.png" end
    if tile.isRiverSource then tile.source = "red.png" end
    tile._w,tile._h = resizeImage(game:getSource(tile.source),tile.w,tile.h)
    tile.children = {}
    return tile
end

function regenerateTerrain(x, y, func)
    --x, y are scaled
    old = tiles[x][y]
    __y = y
    __x = x
    local rivers = {}
    x,y = scaleCoords(x,y)

    local elevation = (func == getHeight and func(x,y)) or old.height
    local temperature = (func == getTemperature and func(0,y,{height=elevation})) or old.temp
    local moisture = (func == getMoisture and func(x,y,{height=elevation})) or old.moisture
    
    --scale(love.math.noise(x*F,y*F, 0)*A)
    local tile = getBiome(elevation, temperature, moisture)
    tile.w, tile.h = _tile.w, _tile.h
    --log(lume.serialiqze(tile))
    
    tile.height = elevation
    tile.moisture = moisture
    tile.temperature = temperature
    tile.temp = tile.temperature
    
    tile.ttx=__x
    tile.tty=__y
    tile.source = "biomes/"..lume.randomchoice(tile.sources).."/"..tile.height.name..".png"
    if tile.isRiver then tile.source= "player.png" end
    if tile.isRiverSource then tile.source = "red.png" end
    tile._w,tile._h = resizeImage(game:getSource(tile.source),tile.w,tile.h)
    return tile
end

function getRiver(x,y)
    local n = getNoise(x,y,mapGen.river)
    if n>0.998 then
        return truye
    end
end
allTiles={}
tiles={}
_tile = {w=16,h=16}
function getHeight(x,y)
    local n = loadNoise(x,y)
    for i,height in ipairs(mapGen.heights) do
        height.pos = i
        local value = height.value
        if type(value) == "table" then
            value = lume.randomchoice(value)
        end
        if n < value then
            local v = lume.copy(height)
            v.realValue = n
            return v
        end
    end
end

function reload(func)
    _allTiles =lume.copy(allTiles)
    allTiles = {}
    for i,u in ipairs(_allTiles) do
        local t = regenerateTerrain(u.ttx,u.tty,func)
        storeTile(t)
    end
end

function storeTile(t)
    table.insert(allTiles,t)
    tiles[t.ttx] = tiles[t.ttx] or {}
    tiles[t.ttx][t.tty] = t
    return t
end

function getTemperature(x,y,t) function pp(m) if m<0 then return m*-1 else return m end end
    local lat = pp(__y)/2
    local mapH = mapSize.value*10
    local ele = t.height.realValue
    --decreases temp value by increasing latitude
    local tempMultiplier = 9.9
    local tempHeight = 0.1 -- value at which to decrease temp?
    local tempLoss = 0.1 -- value at which temp is lost per step?
    local n = 1   -((lat/(mapH/2))*t.height.realValue)
       --[[ (
            ( lat/mapH ) * (-tempMultiplier)
        ) -
        (
            (ele/tempHeight) *tempLoss
        )*
        0.1
    )
    n=n+ 1 -- the base temperature
]]n=0.3
    if n >= 1 or n<0 then n=0.2 t.height.name = "DeepWater" t.height.realValue = 0.1  end
    
    --[[if __y/mapSize.value >= mapSize.value then __y = ((__y/mapSize.value)%mapSize.value)*mapSize.value end   if __y == 0 then __y=1 end
    local n = (mapSize.value%pp(__y))
    log("__y"..__y) log(n)
    n= n/mapSize.value-- getNoise(x,y,mapGen.temperatures)

    t = t or {height={}}
    if n>=1 then
        n= 0.89
    elseif n==0/0 then 
        n = 0.2
    end
    --???n=n*t.height.realValue
    if t.height.name == "Grass" then
        n = n-0.1*t.height.realValue
    elseif t.height.name == "Forest" then
        n = n-0.3*t.height.realValue
    elseif t.height.name == "Rock" then
        n = n-0.3*t.height.realValue
    elseif t.height == "Snow" then
        n = n-0.4*t.height.realValue
    end]]
    for i,temp in ipairs(mapGen.temperatures) do
        temp.pos = i
        if n < temp.value then
            local v = lume.copy(temp)
            v.realValue = n
            return v
        end
    end
end

function getMoisture(x,y,t)
    local n = loadNoise(x,y,mapGen.moisture)
    t = t or {height={}}
    if t.height.name == "DeepWater" then
        n = n+0.8*t.height.realValue
    elseif t.height.name == "ShallowWater" then
        n = n+0.3*t.height.realValue
    elseif t.height.name == "Sand" then
        n = n+0.1*t.height.realValue
    elseif t.height == "Grass" then
        n = n+0.25*t.height.realValue
    end
    if n >=1 then n = 0.99 end
    for i,moisture in ipairs(mapGen.moisture) do
        moisture.pos = i
        if n < moisture.value then
            local v = lume.copy(moisture)
            v.realValue = n
            return v
        end
    end
end

function getBiome(elevation, temperature, moisture)
    local ev = elevation.pos
    local temp = temperature.pos
    local m = moisture.pos
    local _biome = biomes[m][temp]
    local isWater = nil
    if elevation.name == "DeepWater" or elevation.name == "ShallowWater" then-- and
      ---  moisture.realValue > mapGen.moisture[4].value then
           -- _biome = "Ocean"
           isWater = true
    end


    local biome = Biomes[_biome]
    biome.name = _biome
    local b = lume.copy(biome)
    b["is"..elevation.name] = true
    b.isWater = isWater
    return b
end



function love.mousereleased()
    gooi.released()
end