+_!
StateMachine = class:extend("StateMachine")

function StateMachine:__init__(kwargs)
    local 
    N, H, S, D, E, F, DE, SA, T, None = "N", "H", "S", "D", "E", "F", "DE", "SA", "T", "None"
    self._observations = {
        SL = {N,H,S,None},
        C = {N,H,S,D,E,F,DE,SA,T,None},
        A = {N,H,S,D,E,F,DE,SA,T,None},
        P = {D,E,F,DE,SA,T,None},
        PN = {N,D,E,F,DE,SA,T,None},
    }
    
    self.stateTransitionTable = stateTransitionTable
    self.map = kwargs.map or {}
    self._info = self.map.observations
end

function StateMachine:peformStateMachine(obj)
    local acted = nil
    local cs = self:currentState(obj)
    local obs = self:observe(obj)
    local sm = self.stateTransitionTable
    local inputs
    while not acted
        inputs = self:observe(sm[cs][obs])
        shifted = nil
        for index,i in lume.iter(inputs) do
            if not shifted then
                if self:inputIsTrue(i) then
                    --get probability to shoft to next state
                    probShift = self:getProbShift(sm[cs][i])
                    if math.random()<probShift then
                        cs = sm[cs][i].state or sm[cs][i][1]
                        shifted = true
                        break
                    end
                end
            else
                break
            end
        end
        if sm[cs].action ~= nil then
            self:doStatelessAI(sm[cs].action,obj)
            acted = true --??
        end
    end
end

function StateMachine:currentState(obj)
    return obj.currentState or (obj.stats and obj.stats.currentState)
end

--Inputs and meaning:
---N(Noise Detected)
---H(User Hungry)
---S(Strange Smell Detected)
---D(Dead Comrade Detected)
---E(Alive Enemy Seen)
---F(Friend Seen)
---DE(Dead Enemy Seen)
---SA(User Satisfied)
---T(User Tired)
---None(No Input Gotten)

function StateMachine:observe(_obs)
    local 
    N, H, S, D, E, F, DE, SA, T, None = "N", "H", "S", "D", "E", "F", "DE", "SA", "T", "None"
    
    local tile = obj.tile.id or tostring(obj.tile)
    local vals = self._info
    local obs = self._observations[_obj]
    local v
    
    local re = obj:getObservable(function(_tile)
        local tile = _tile.id or tostring(_tile)
        local val = vals[tile]
        local unit = _tile.unit
        
        for x,i in ipairs(obs) do
            if i == N then
                v = val.noise
                if v then return v end
            elseif i == H then
                return obj:isHungry()
            elseif i == S then
                v = val.smell
                if v then return S end
            elseif i == D then
                if unit then
                    if obj:isAlly(unit) and obj:isDead(unit) then
                        return D
                    end
                end
            elseif i == E then
                if unit and not obj:isAlly(unit) then
                    return E
                end
            elseif i == F then
                if unit and obj:isAlly(unit) then
                    return F 
                end
            elseif i == SA then
                if obj:isSatieted() then
                    return SA
                end
            elseif i == T then
                if obj:isTired() then
                    return T
                end
            end
        end
    end)
    
    --very unlikely
    if not re then
        return None
    end
    
    return re
end

function StateMachine:inputIsTrue(input)
end

function StateMachine:doStatelessAI(action,obj)
    statelessAI[action](obj)
end

function StateMachine:getProbShift(input)
    return input[2] or input.probability
end