
local 
N, H, S, D, E, F, DE, SA, T, None = "N", "H", "S", "D", "E", "F", "DE", "SA", "T", "None"

StateMachine = class:extend("StateMachine")

function StateMachine:__init__(kwargs)
    self._observations = {
        SL = {N,H,S,None},
        C = {N,H,S,D,E,F,DE,SA,T,None},
        A = {N,H,S,D,E,F,DE,SA,T,None},
        P = {D,E,F,DE,SA,T,None},
        PN = {N,D,E,F,DE,SA,T,None},
    }
    
    self.stateTransitionTable = stateTransitionTable
    self.map = kwargs.map or {}
    self._info = self.map.observations
    self.peform = self.peformStateMachine
end

function StateMachine:peformStateMachine(obj)
    local acted = nil
    local sm = self.stateTransitionTable
    local cs = self:currentState(obj)
    local obs = sm[cs].obs--self:observation(obj)
    
    local i = self:observe(obj,obs)--sm[cs][obs])
    log("observed "..i)
    if i~=None then warn() end
    
    shifted = nil
    --get probability to shift to next state
    log(cs..i)
    probShift = self:getProbShift(sm[cs][i])
    if math.random()<probShift then
        cs = sm[cs][i].state or sm[cs][i][1] or cs
        shifted = true
    end
    obj.stats.currentState = cs
    
    if sm[cs].action ~= nil then
        self:doStatelessAI(sm[cs].action,obj)
        acted = true --??
    end

end

function StateMachine:currentState(obj)
    return obj.currentState or (obj.stats and obj.stats.currentState)
end

--Inputs and meaning:
---N(Noise Detected)
---H(User Hungry)
---S(Strange Smell Detected)
---D(Dead Comrade Detected)
---E(Alive Enemy Seen)
---F(Friend Seen)
---DE(Dead Enemy Seen)
---SA(User Satisfied)
---T(User Tired)
---None(No Input Gotten)

function StateMachine:observe(obj, _obs)

    local vals = self._info
    local obs = self._observations[_obs]
    local v
    
    local re = obj:getObservable(function(_tile)
        local tile = _tile.id or tostring(_tile)
        local val = vals[tile] or {}
        local unit = _tile.unit
        
        for x,i in ipairs(obs) do
            if i == N then
            log(self.map.turn.value.."::")
                v = vals[self.map.turn.value][val.id] 
                if v then v=v.noise end
                if v then warn(v.."!!!!!!!H") return H end
            elseif i == H then
                if obj:isHungry() then return H end
            elseif i == S then
                v = val.smell
                if v then return S end
            elseif i == D then
                if unit then
                    if obj:isAlly(unit) and obj:isDead(unit) then
                        return D
                    end
                end
            elseif i == E then
                if unit and not obj:isAlly(unit) then
                    return E
                end
            elseif i == F then
                if unit and obj:isAlly(unit) then
                    return F 
                end
            elseif i == SA then
                if obj:isSatieted() then
                    return SA
                end
            elseif i == T then
                if obj:isTired() then
                    return T
                end
            else
                return None
            end
        end
    end)
    
    --very unlikely
    if not re or type(re)~="string" then
        error("No state switched in machine")
        return None
    end
    
    return re
end

function StateMachine:inputIsTrue(input)
end

function StateMachine:doStatelessAI(action,obj) log(action)
    StatelessAI[action](obj)
end

function StateMachine:getProbShift(input) log(input)
    return (input and (input[2] or input.probability)) or 0
end

return StateMachine