local random = math.random
return {

    battleAI = function(obj,target)
        --[[
                tooFarFromEnemy: can't use melee attack?
                tooCloseToPlayer: can use melee attack
                
                archer:
                        retreatProb -> returns 1(max)
                        chargeProb  -> returns 1(max)
                        
                animal:
                        tooCloseTo  -> returns false
                        tooFarFrom  -> returns true
                        chargeProb        -> returns 1(max)
                        
                        
        ]]
        
        local damage = obj:getDamage()
        local morale = obj.stats.morale
        local target = obj:getTarget() or target or obj.target or obj
        obj.target = target
        
        if not target and target.stats.active then
                
        end
        
        assert(obj:isMyTurn(),obj.stats.alias)
        if damage>morale then
                local canRunAway = not obj.moved and obj:moveAwayFrom(target)
                if not canRunAway and obj:canAttack(target) then
                        obj:attack(target)
                elseif not canRunAway then
                        obj:standStill()
                end
                
        elseif obj:tooFarFrom(target) and obj:canAttack() then
                if random()<obj:chargeProb() and not obj.moved and obj:moveTo(target) then
                        --moved to target
                else
                        obj:attack(target)
                end
                
        elseif obj:tooCloseTo(target) and obj:canAttack(target) then
                if random()<obj:retreatProb() and not obj.moved and obj:moveAwayFrom(target) then
                        --moved away from target
                else
                        obj:attack(target)
                end
                
        elseif obj:canAttack(target) then
                obj:attack(target)
                
        elseif obj:tooFarFrom(target) and not obj.moved and obj:moveTo(target) then
                --moved to target
        
        elseif obj:tooCloseTo(target) and not obj.moved and obj:moveAwayFrom(target) then
                --moved away from target
        else
                obj:standStill()
        end
        --if the unit has not moved or attacked
        if not obj.path and not obj.attacking then
                assert(not obj:attackActive())
                obj.done = true
                log("!!!!!!")
        end 
        tx,ty=target:getPos()
        xx,yy=obj:getPos()
    end,

    sleepingAI = function(obj)
        local trash = obj.sleep and obj:sleep()
        obj.done = true
    end,
    
    curiousAI = function(obj)
        local map = obj.map
        local moveTo = {}
        local mov = obj.stats.sight
        map.fov:compute(obj:getX(),obj:getY(),mov,function(x,y)
            t = map.grid[x] and map.grid[x][y]
            if t then
                table.insert(moveTo, t)
            end
        end)
        
        obj.bonus.speed = 2  
        local tile = lume.randomchoice(moveTo)
        obj:moveTo(tile)
    end,
    
    calmAI = function(obj)
        obj.done = true
    end,
    
    enragedAI = function(obj)
        obj.done = true
    end,
    
    boredAI = function(obj)
        local map = obj.map
        local moveTo = {}
        local mov = obj.stats.sight
        map.fov:compute(obj:getX(),obj:getY(),mov,function(x,y)
            t = map.grid[x] and map.grid[x][y]
            if t and t.type~="wall" then
                table.insert(moveTo, t)
            end
        end)
        
        obj.bonus.speed = 2  
        local tile = lume.randomchoice(moveTo)
        log("bored is moving")
        local p = obj:moveTo(tile)
        if not p then warn("!!") obj.done = true end
    end,
    
    eatingAI = function(obj,target)
        obj.done = true
    end,
    
    hungryAI = function(obj)
        obj.done = true
    end,
    
    None = function() 
        obj.done = true
    end,
    
}