Game = {}


gooi.desktopMode()

function Game:log(l)
    log(l)
end

function Game:quit()
    love.event.quit()
end

function Game:enter()
    self.__init__()
end

function Game:getColor(color)
    local col =  self.color[color]
    if not col then
     --   return self.color.black
    end
    return col
end

function Game:reset()
    resetAll()
end

function Game:start()
  --  splash = Splash:new()
--    GSS(splash)
   -- splash:addSplash(self:getSource("icon.png"),.000001)
    --splash:addSplash(self:getSource("kiventlogo.png"),1.5)
   -- splash:onComplete(function()
        --self:startNewGame()--
        Gamestate.switch(mainMenu)
   -- end)
    
end

function Game:pause()
end

function Game:update(dt)
end

function Game:new(o)
    local o = o or {}
    setmetatable(o, self)
    self.__index = self
    return o
end

function Game:startSavedGame()
end

function Game:startNewGame()
    b = Overworld:new(Camp:new())
    b.camp.map = b
    bover =b
    gooi.removeComponent(mainMenu.load)
    gooi.removeComponent(mainMenu.menu)
  --bb = Underground:new({w=50,h=50})
  -- GSS(bb)
      Gamestate.switch(b)
       -- if 2 then self:loadDungeon(9,{creature="Glop"}) end
end

function Game:hasSavedGame()
end

function Game:__init__(debug)
    self._sources = {}
    self._storage = {}

    self.debugInfo = debug or true
    self.debug = debug or true
    self.debugLabel = 
     gooi.newLabel({text = "Debugger", x = 50, y = 85, w = 70, h = 10}):left()
    self.color = color
    --[[self:loadVars()
    self:loadMap()
    self:loadActors()]]--
    
    self.tmp = {}
    self.setText=function(...) self.debugLabel:setText(...) end
    

end

function Game:getSource(source)
    if self._sources[source] == nil then
        self._sources[source] = Graphics.newImage("assets/"..source)--scale later
    end
    return self._sources[source]
end

function Game:getAsset(...)
    return self:getSource(...)
end

function Game:reset()
end


function Game:draw()
end

function Game:released(x, y, button) gooi.released(x,y,button) end
function Game:pressed(x, y, button)  gooi.pressed(x,y,button) end

function Game:touchreleased(id, x, y, dx, dy, pressure)
    if not self.buttonPressed then
        ttx = x
        tty = y
    end
    self.buttonPressed = false
end

function Game:textinput(text)
  gooi.textinput(text)
end

function Game:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
    p:close()
    love.event.quit()
  end
end

function Game:keyreleased(key, scancode) log(key) log("kr")
  gooi.keyreleased(key, scancode)
end

function Game:getData(data,actor,skip)

    if type(data) ~= "table" then
        return self:getActor(data,actor)
    end
    
    if data[1] == "get" then
        local val,_name,_val,op,get2
        _name = data[2]
        _val = data[3]
        op = data[4]
        get2 = data[5]
        local item = self:getActor(_name,actor)
        if OPERATORS[_val] then
            if type(_name) == "table" then
                _name = self:getData(_name,actor)
            end
            get2 = op
            op = _val
            val = _name
        else
            val = item[_val]
        end
        if op then
            local g2 = get2
            if type(g2) == "table" then
                g2 = getData(get2,actor)
            end
            val = operate(val,op,g2)
        end
        return val
    else
        if not skip then
            for _,i in ipairs(data) do
                if type(i) == table then
                    data[_] = self:getData(i,actor,true)
                end
            end
            for _,i in pairs(data) do--????
                if type(i) == table then
                    data[_] = self:getData(i,actor,true)
                end
            end
        end
        return data
    end
end

function Game:loadDungeon(unit,tile)
    u={}
    for x=1,9 do table.insert(u,Unit:new()) end
    local d = Dungeon:new({
        data=allCreatures[tile.creature].dungeon,
        units=u,
        player=bover.camp})
    GSS(d)
end

--stores an object by its id
function Game:store(object)
    self._storage[tostring(object)] = object
end

--gets an object by its id
function Game:get(object)
    local id = (type(object) ~= "table" and object) or tostring(object)
    local obj = self._storage[id]
    if not obj then
        warn("Object "..tostring(object).." of type "..type(object).." not found")
        return false
    end
    return obj
end

function Game:loadLua(code,actor)
    --Abusing löve2d to load lua code from files.
    --There may be a better way to do this, but wateves...
    local tmpLua = love.filesystem.newFile("tmpLua.lua","w")
    tmpLua:write(code)
    tmpLua:close()
    local func = love.filesystem.load("tmpLua.lua")
    self.actor = actor
    return func()
end

function Game:getActor(id,actor)
    if actor then
        if id == "self" then
            return actor
        end
    end
    if id == "game" then
        return self
    elseif id == "user" then
        return self.tmp.user
    elseif id == "target" then
        return self.tmp.user and self.tmp.user.target
    elseif id == "map" then
        return self.map
    end
    
end

function Game:decodeScript(script,user,obj)

    --actor will be the one whose values gets changed
    --self is the object the script belongs to
    
    local _obj = obj
    local _if = lume.copy(script._if)
    local obj = obj or script
    
    local actor = self:getActor(script.actor,obj)
    
    self.tmp.user = user
    self.tmp.obj = obj
    self,tmp.actor = actor
    
    if type(_if) == "table" then
        _if = self:getData(_if, obj)
    end
    if not _if then
        return false
    end
    
    for name, data in ipairs(script) do
        if name == "_if" then
            goto continue
        end
        if type(data) == "table" then
            data = self:getData(data,obj)
            if type(data[1]) == "string" then
                local loc = data[1]
                if self.positions[loc] then
                    local pos = self.positions[loc]
                    pos.x = pos.x+data[2]
                    pos.y = pos.y+data[3]
                end
            end
        end
        if name == "anim" then
            local anim = self:loadLua(data,actor)
            anim:start()
        elseif name == "wait" then
            scriptIsBusy = scriptIsBusy+data
        elseif name == "decode" then
             for _,x in lume.iter(data) do 
                self:decodeScript(x, user, _obj)
            end
        elseif name == "goal" then
            actor:moveTo(data)
        elseif name == "acts" then
            for _,code in pairs(data) do
                self:loadLua(code,actor)
            end
        elseif name == "attackBehaviour" then
            actor.battle = self.attackBehaviours[data] or self:loadLua(actor,data)
        elseif name == "attacks" then
            for attack,val in lume.iter(data) do
                actor.attacks[attack] = self.attacks[attack] or self:loadLua(actor,val)
            end
        end
        actor[name] = data
        ::continue::
    end
    --Just because
    return actor
end

return Game