local Map = GridMap


DT = 0
DTmax = .5

BattleScene = GridMap:extend("BattleScene")


function BattleScene:log(l)
    log(l)
end


function BattleScene:enter()
 --   self:__init__()
end



function BattleScene:doBattleAI(obj)
    if not obj then
        self.currentUnit.done = false
        self.currentUnit.moved = false
        self.currentUnit.selected = true
        self.currentUnit:play()
    end
    log("DoingIT"..self.turn.data)
    battleAI(self.currentUnit)
    if obj then
        if not self.currentUnit.attacking then
            assert(not self.currentUnit:attackActive())
            self.currentUnit.done = true
            self.currentUnit.attacking = true
        end
    end
    for x,i in ipairs(self._units) do
        for t,y in lume.iter(i) do
            assert(not y.done,y.isEnemy)
        end
    end
    --self.scheduler = Scheduler:new()
    self.scheduler:schedule(
    function() log(#self.scheduler._schedules..'!') return self.currentUnit.done end,
    function()
        --check if anything is in range to attack
        
        if not self.currentUnit.attacking then
            self.currentUnit.moved = true
            self.currentUnit.done = false
            return self:doBattleAI(self.currentUnit)
        end
        
        self.currentUnit.attacking = false
        self.currentUnit.selected = false
        --reseting current unit
        assert(self.currentUnit.done)
        self.currentUnit.done = false
        self.currentUnit.target = nil
        --give another unit a shot
        lume.remove(self.actingUnits,self.currentUnit)
        self.currentUnit = self.actingUnits[1]
        if not self.currentUnit and self.turn.data~="PLAYER" then
            log("toggling out of"..self.turn.data)
            self.turn:toggle()
        elseif self.currentUnit then
            self.currentUnit:play()
            self.currentUnit.selected = true
            self:doBattleAI()
        else
            --commander's time
            self.player.ready = true
        end
    end
    )
end

function BattleScene:start()
  -- Gamestate.switch(mainMenu)
end

function BattleScene:peformPlayerAI()
    self.actingUnits = lume.copy(self.units)
    lume.remove(self.actingUnits,self.player.commander)
    for x,g in ipairs(self.units) do
        assert(not g.attacking)
        g.attacking = nil
        if not g.stats.active then
            lume.remove(self.actingUnits,g)
        end
    end
    self.currentUnit = self.actingUnits[1]
    if not self.currentUnit then
        if not self.player.commander or not self.player.commander.stats.active then
            self.set("...","exit")
            self.player.won = false
            return self.turn:toggle()
        else
            self.player.ready = true
            return
        end
    end
    self:doBattleAI()
end

function BattleScene:peformAI(units)
    self.actingUnits = lume.copy(units)
    for x,g in ipairs(units) do
        assert(not g.attacking)
        g.attacking = nil
        if not g.stats.active then
            lume.remove(self.actingUnits,g)
            warn()
        end
    end
    self.currentUnit = self.actingUnits[1]
    if not self.currentUnit then
        self.set("...","exit")
        self.player.won = true
        return self.turn:toggle()
    end
    self:doBattleAI()
end

function BattleScene:update(dt)
    self:callSuper("update",dt)
    local trash = self.pop and self.pop:update(dt)
    self.player:update(dt)
    gooi.update(dt)
    self.scheduler:update(dt)
    if self.turn.data == "ENEMY" then-- and self.player.shaking <=0 then
        if PLAYER then
            log("\nENEMY TURN\n")
            self:peformAI(self.enemies)
        end
        PLAYER=nil
    elseif not PLAYER and self.turn.data == "PLAYER" then--player.shaking <=0 then
        log("\nPLAYER TURN\n")
        self.player.ready = false
        self.player.moved = false
        PLAYER=1
        self:peformPlayerAI()
        self.enemyAI.acted = false
    end
    self.scolorTiles = {}
    for _,xy in lume.iter(self._units) do
        for _,u in lume.iter(xy) do
            u:update(dt)
            
            if u.isEnemy then
               self:scolorTile(u.tile,"red")
            end
        end
    end

    local cameraSpeed = self.cameraSpeed
    local m = {x=self.cameraMan.x,y=self.cameraMan.y}
    if self:isDown("exit") then
        self.player:endBattle(self.player.won)
    elseif self:isDown("zoom in") then
        self.camera.scale= self.camera.scale*1.5
        self:rePopUp()
        self.cameraSpeed = self.cameraSpeed/1.5
    elseif self:isDown("zoom out") then
        self.camera.scale = self.camera.scale/1.5
        self:rePopUp()
        self.cameraSpeed = self.cameraSpeed*1.5
    elseif self:isDown("left") then
        m.x = self.cameraMan.x-self.tileW
        m.moved = true
    elseif self:isDown("right") then
        m.x = self.cameraMan.x+self.tileW
        m.moved = true
    elseif self:isDown("up") then
        m.y = self.cameraMan.y-self.tileH
        m.moved = true
    elseif self:isDown("down") then
        m.y = self.cameraMan.y+self.tileH
        m.moved = true
    end
    self.cameraMan.x = m.x
    self.cameraMan.y = m.y
    if m.moved then
        self:rePopUp()
    end
    if m.momved then--not self.cameraMan.animation and m.moved then
        self.cameraMan.animation = Animuation:new({x=m.x,y=m.y,d=cameraSpeed})
        self.cameraMan.animation:start(self.cameraMan)
        self.cameraMan.animation:update(dt)

    end
    local maxZoom = 10
    local minZoom = 0.05
    if self.camera.scale >  maxZoom then
        self.camera.scale = maxZoom-1
        self.cameraMan.animation= nil
    elseif self.camera.scale < minZoom then
        self.camera.scale = minZoom+0.01
    end
        
end
    
function BattleScene:__init__(units, load, player)
    PLAYER = nil
    self._popUp = {}
    
    
    self.super.__init__(self)
    self.cameraSpeed = 0.02
    self.usePaddy = true
    self.set = self.paddy.setButtonText
    local set = function(...) return self.paddy:setButtonText(...) end
    self.set = set
    set("a","menu")
    set("x","zoom out")
    set("y","zoom in")
    set("b","...")
    
    self.dontSave = true
    
    units = units or {}
    self._units = units or {}
    self.units = units.units or units.playerUnits or {}
    self.enemies = units.enemies or {}
    self.player = player or self.player
    
    self.player.units = self.units
    self.player:getRandomCommander()
    self.player:getBattleReady()
    
    self.colorTiles = {}
    self.scolorTiles = {}
    self.scheduler = Scheduler:new()
    if load then
        self:placeUnits()
    end
    
    self.camera.scale = 1.5
    --self.turn = Toggle:new({"PLAYER","ENEMY"}):onToggle(function(data)
      --  if data=="PLAYER" then
        --    local d = self.player.selected
           -- if d.stillMoving then
   --     end
--    end)
    self.enemyAI = AI:new(self.enemies)
    self.player.resetChoice = function(self)
        if self.selected then
            self.selected._goal = nil
            self.selected.selected = nil
        end
        self.moved = nil
        self.selected = nil
    end
    
end

function BattleScene:isWalkable(val)
    local tile=val
   -- self:colorTile(tile,"yellow")
    if self.c_unit._goto ==val then
       return true
    end
    if self.map.tiles[val.gid].properties.collidable then
        self:colorTile(tile,"yellow")
        return false
    elseif val.unit then
        self:colorTile(tile,"blue")
        sprint = tile.unit
        if sprint.isEnemy then return false end
        if self.c_unit then
            if self.c_unit.target == tile.unit then 
                return true 
            end
        end
        return false---ccc??????
    end
    return true
end

function BattleScene:placeUnits()
    local row = 0
    local col = 1
    --log(self.grid)
    for _,xx in lume.iter(self.units) do
    xx.stats.movementRange = 11
        xx.stats.alias = "PLAYER"
        row = row + 1
        if row > self.map.height+1 then
            col = col+1
            row = 1
        end
        tile = self.grid[col] and self.grid[col][row]
        assert(self.grid[col],"Tile is not gotten at col "..col)
        assert(tile,"Tile is not gotten at row "..row)
        if tile then
            self:placeUnit(xx,tile)
        end
    end
    row = 0
    col = self.map.width+1
    for _,xx in lume.iter(self.enemies) do
        xx.stats.alias = "ENEMY"
        --xx.stats.movementRange = 1
        row = row + 1
        if row > self.map.height+1 then
            col = col-1
            row = 1
        end
        tile = self.grid[col] and self.grid[col][row]
        --error(col)

        assert(self.grid[col],"Tile is not gotten at col "..col)
        assert(tile,"Tile is not gotten at row "..row)
        if tile then
            xx.isEnemy = true
            self:placeUnit(xx,tile)
        end
    end
    local s = math.floor(#self.grid/2)
    local ss = math.floor(#self.grid[math.floor(#self.grid/2)]/2)
    local t = self.grid[s][ss]
    self.cameraMan = {x=t._x,y=t._y}
end

function BattleScene:loadTile(_tile,x,y)
    if not _tile then
        return
    end
    local tile = self:getTile(_tile,x,y)
    tile.fromBattleScene = true

    tile._x = tile.w*tile.x
    tile._y = tile.h*tile.y
    for u in pairs(_tile) do
        tile[u] = tile[u] or _tile[u]
    end
    tile.unit = nil
    
    self.map.grid[x] = self.map.grid[x] or {}
    self.map.grid[x][y] = tile
    self.map.tiles[tile.id] = tile
    tile.gid = tile.id
    table.insert(self.allTiles, tile)
    store(tile)
end

function BattleScene:placeUnit(unit, tile)
    log("placing "..tile._x..", "..tile._y)
    assert(not unit.isCamp)
    local _tile = self.map.tiles[tile.gid]
    unit.x = tile._x
    unit.y = tile._y
    unit.w = _tile.w
    unit.h = _tile.h

    unit.tile = tile
    unit.map = self
    tile.unit = unit
end
function BattleScene:scolorTile(tile,color)
    table.insert(self.scolorTiles,{tile,color})
end

function BattleScene:draw()
    self:callSuper("draw")
    self.camera:attach()
   --[[ grid = lume.copy(self.grid)
    table.insert(grid,self.grid[0])
    for x,jc in ipairs(grid) do 
        _jc = lume.copy(jc)
        table.insert(_jc,grid[x][0])
        for u,c in ipairs(_jc) do
            color = "green"
            if c.unit then
                color = "blue" 
                if c.unit.isEnemy then 
                    color = "red" 
                end
                if not c.oldUnit then 
                    color = "cyan"
                end
                c.oldU = 1
            else
                c.oldU = nil
            end
            love.graphics.setColor(game:getColor(color))
            love.graphics.rectangle("fill",c._x,c._y,16,16)
            love.graphics.setColor(1,1,0)
            l,k = self.map:convertPixelToTile(c.x,c.y)
            love.graphics.setColor(game:getColor("black"))
            love.graphics.print(l..", "..k,c._x,c._y,0.25,0.25)
            love.graphics.setColor(1,1,0)
        end
    end]]--
    for nx,i in lume.iter(self.colorTiles) do
      --  self:_colorTile(i[1],i[2])
    end
    for _,xn in lume.iter(self._units) do
        for _,u in lume.iter(xn) do
            u:draw()
        end
    end
    for nx,i in lume.iter(self.scolorTiles) do
        --self:_colorTile(i[1],i[2])
    end
    
    self.camera:detach()
    if sprint then
        love.graphics.print(sprint,W()/2,100) end
    love.graphics.print(sprint2 or "",W()/2,200)
    love.graphics.print(self.turn.data.."'s TURN!!",W()/2,70,0,1.4,1.4)
  --  self.camera:attach()
    gooi.draw()
    local trash = self.pop and self.pop:draw()
    --self.camera:detach()
    
    self.camera:draw()
end

function BattleScene:mousereleased(x, y, button)
    local trash = self.pop and self.pop:mousereleased(x,y,button)
    gooi.released()
end

function BattleScene:mousepressed(x, y, button)
    local trash = self.pop and self.pop:mousepressed(x,y,button)
    gooi.pressed()
end

function BattleScene:touchreleased(id, x, y, dx, dy, pressure)
    local trash = self.pop and self.pop:touchreleased(id,x,y,dx,dy,pressure)
    if trash then
        self.buttonPressed = true
    end
    if self.turn.data ~= "PLAYER" then
        return
    end
    if not self.buttonPressed then
        ttx = x
        tty = y
    else
        self.buttonPressed = false
        return
    end
    x,y = self.camera:toWorldCoords(x,y)
   
    local tile = self:getTileWithPos(x,y)
            local sx,sy = self.map:convertPixelToTile(x,y)
            sx = math.floor(sx)
            sy = math.floor(sy) sprint2 = sx..", "..sy
    if tile then
        local now = nil
       -- table.insert(self.colorTiles,{tile,"red"})
      -- self:colorTile(tile,"red")
       sprint2 = sprint2.."yah"
   --     self.cameraMan = {x=x,y=y}
   
        local target = tile.unit
        self.tmpselected = target
        local unit = self.player.selected
        if tile.unit then
            self.tmpselected = tile.unit
            if not self.player.selected then
                if target.isEnemy then
                    self:popUp(2,target)
                elseif not target.stats.commander then
                    self:popUp(1,target)
                elseif target.stats.commander then
                    self:popUp(3,target)
                end
            elseif self.player.selected and not target.stats.active and
            unit:inRange(1,target) then
                self:popUp(9,target)
            elseif self.player.selected and not self.player.moved then
                if target==unit then
                    --end turn
                    self:popUp(6,unit)
                elseif target and unit:inAttackRange(target) then
                    --attack
                    self:popUp(5,target)
                elseif  target.stats.alias == "PLAYER" then
                    --manager of units?
                    --but for now...
                        local f = self.pop and self.pop:destroy()
                        self.pop = nil
                end
            elseif self.player.selected and self.player.moved then
                if target==unit then
                    --undo
                    self:popUp(8,target)
                elseif target and unit:inAttackRange(target) then
                    --attack
                    self:popUp(5,target)
                end
            end
        else
            self.tmpselected = tile
            if self.player.moved and unit:inAttackRange(tile) then
                --attack a tile?
                self:popUp(7,tile)
        
            elseif self.player.selected and not self.player.moved then
                --move
                self:popUp(4,tile)
            else
                --remove all popUps?
                if self.pop then
                    self.pop:destroy()
                    self.pop = nil
                end
                --self:popUp(1,tile)
            end
        end
    end
end

function BattleScene:moveTo(tile)
    --move player.selected to a tile
    self.buttonPressed = true
    assert(tile~=self.player.commander)
    local sx,sy = tile:getX(),tile:getY()
    local s = self.player.selected
    s.oldx, s.oldy = s:getPos()
    if  self.player.selected.moveID == tile.moveID 
      and 
      self.player.selected.tile ~= tile then
        sprint2 = sx..", "..sy..": "..tostring(tile.unit)
        --self.tmpselected = tile.unit
        if tile ~= self.player.selected.tile then
            log("Staaararararat")
            self.player.selected:moveTo(sx,sy)
            self.player.selected._goal = {sx,sy}
            self.player.moved = self.player.selected
            --self.turn:toggle()
            self.colorTiles = {}
            if self.pop then
                self.pop:destroy()
            end
            self.pop = nil
        end
        
        self.colorTiles = {}
    end
    -- self.colorTiles = {}
end
    
function BattleScene:popUp(num, obj)
    if not self.player.ready and
         num ~=1 then
         return
    end
    self._popUp = {num,obj}
    self.playerMoved = true
    if self.pop then
        self.pop:destroy()
    end
    local sh = 2
    local sw = 8--16
--elf.camera.scale
    gooi.removeComponent(self.pop)
    local g= self.grid[1][1]
    local fx,fy = self.map:convertPixelToTile(-10,30)
    local x,y = obj.x,obj.y
    if obj.isTile then
        x,y = obj._x,obj._y
    end
    local xx, yy =self.camera:toCameraCoords(x,y)
   -- local yy= 16--00--yy-100
    yy = yy-(obj.h*5)
    
    local select = function(obj)
        self.pop:destroy()
        self.buttonPressed = true
        self.colorTiles = {}
        if self.player.selected then
            self.player.selected.selected = false
        end
        obj:play()
        self.player.selected = obj
        obj.selected = true
        self.player.selected.moveID = lume.uuid()
        local sx,sy = self.map:convertPixelToTile(obj.tile.x,obj.tile.y)
        sx = math.floor(sx)
        sy = math.floor(sy)
        self.fov:compute(sx,sy,self.player.selected.stats.movementRange,
            function(x,y)
                local tile  = self.grid[x] and self.grid[x][y]
                if not tile then return end
                tile.moveID = self.player.selected.moveID
                --self:colorTile(tile,"red")
            end
        )
    end

    local endturn = function()
    
        if self.pop then
            self.pop:destroy()
        end
        self.pop = nil
        self.buttonPressed = true
        self.colorTiles = {}
        local s = self.player.selected
        if s then
            s.selected = false
        end
        self.player.selected = nil
        self.player.moved = false
        self.player.ready = false
        self.turn.data = "ENEMY"
        self.enemyAI.acted = false
    end
    self.endturn = endturn
    
    if num == 1 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"MAKE COMMANDER","END TURN"},
            onRelease=function(t)
                if  t=="END TURN" then
                    endturn()
                elseif t=="MAKE COMMANDER" then
                    self.player:changeCommander(self.tmpselected)
                    self.player.moved = false
                    self.pop:destroy()
                    self.pop = nil
                end
            end
    
        })
        self.pop = pop
    
    elseif num == 2 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"END TURN"},
            onRelease=function(t) if  t=="END TURN" then endturn() end end
    
        })
        self.pop = pop

    elseif num == 3 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"SELECT","END TURN"},
            onRelease=function(t)
                if t=="SELECT" then
                    select(obj)
                elseif t=="END TURN" then
                    endturn()
                end
            end
        })
        self.pop = pop
        
    elseif num == 4 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"MOVE HERE","END TURN"},
            onRelease=function(t)
                if t=="MOVE HERE" then
                    self:moveTo(obj)--self.tmpselected)
                elseif t=="END TURN" then
                    endturn()
                end
            end
        })
        self.pop = pop
        
    elseif num == 5 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"ATTACK"},
            onRelease=function(t)
                if t=="ATTACK" then
                    local s = self.player.selected
                    s.target = obj
                    if s:inAttackRange(obj) then
                        s:attack(obj)
                    end
                end
            end
        })
        self.pop = pop
        
    elseif num == 6 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"BACK","END TURN"},
            onRelease=function(t)
                if  t=="END TURN" then
                    endturn()
                elseif t=="BACK" then
                    self.player.selected.selected = false
                    self.player.selected = nil
                    self.pop:destroy()
                    self.pop = nil
                end
            end
    
        })
        self.pop = pop
        
    elseif num == 7 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"ATTACK"},
            onRelease=function(t)
                if t=="ATTACK" then
                    local s = self.player.selected
                    s.target = obj
                    if s:inAttackRange(obj) then
                        s:attackTile(obj)
                    end
                end
            end
        })
        self.pop = pop
        
    elseif num == 8 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"UNDO","END TURN"},
            onRelease=function(t)
                if t=="UNDO" then
                    self.colorTiles = {}
                    local ob = self.player.moved
                    if not ob then
                        log("Can't undo!")
                        return
                    end
                    ob:moveTo(ob.oldx,ob.oldy)
                    self.buttonPressed = true
                    local s = self.player.selected
                    if s then
                        s.selected = false
                    end
                    self.player.moved = false
                    --self.player.selected = nil
                    self.pop:destroy()
                elseif t=="END TURN" then
                    endturn()
                end
            end
        })
        self.pop = pop
        
    elseif num == 9 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"LOOT","PUSH"},
            onRelease=function(t)
                local s = self.player.selected
                self.buttonPressed = true
                if t=="LOOT" then
                    s.target = obj
                    if s:inRange(1,obj) then
                        self:destroyPop()
                       -- s:attackTile(obj)
                    end
                elseif t=="PUSH" then
                    if s:inRange(1,obj) then
                        self:push(obj)
                    end
                end
            end
        })
        self.pop = pop
    end
end

function BattleScene:destroyPop()
    if self.pop then
        self.pop:destroy()
        self.pop = nil
    end
end

function BattleScene:push(obj,pusher)
    self:destroyPop()
    local psher = pusher or self.player.selected
    local xdiff,ydiff = obj:getX()-psher:getX(),obj:getY()-psher:getY()
    local p = obj:moveTo(obj:getX()+xdiff,obj:getY()+ydiff)
    log(p) log("!!??")
    return p
end
    
function BattleScene:rePopUp()
    self.camera:update(0.1)
    if not self.pop then
        return
    end
    self.pop:destroy()
    self:popUp(self._popUp[1],self._popUp[2])
end


function BattleScene:textinput(text)
  gooi.textinput(text)
end

function BattleScene:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
    _LOG_FILE:close()
    love.event.quit()
  end
end

function BattleScene:keyreleased(key, scancode) log(key) log("kr")
  gooi.keyreleased(key, scancode)
end

return BattleScene