Biome = require 'biomes'
--sm = require "tools/simplexNoise"
__noise = noise
mapGen = require "mapGen"


local function isDown(m) 
    return paddy.isDown(m)
end
function Linear_Interpolate(a, b, x)
	return  a*(1-x) + b*x
end
function Cosine_Interpolate(a, b, x)
	ft = x * 3.1415927
	f = (1 - math.cos(ft)) * .5

	return  a*(1-f) + b*f
end


--[[Cubic Interpolation:
This method gives very smooth results indeed, but you pay for it in speed. To be quite honest, I'm not sure if it would give noticeably better results than Cosine Interpolation, but here it is anyway if you want it. It's a little more complicated, so pay attention. Whereas before, the interpolation functions took three inputs, the cubic interpolation takes five. Instead of just a and b, you now need v0, v1, v2 and v3, along with x as before. These are: 
v0 = the point before a
v1 = the point a
v2 = the point b
v3 = the point after b ]]
  function Cubic_Interpolate(v0, v1, v2, v3,x)
	P = (v3 - v2) - (v0 - v1)
	Q = (v0 - v1) - P
	R = v2 - v0
	S = v1

	return Px3 + Qx2 + Rx + S
end
Interpolate = Linear_Interpolate
function scale(_noise)
    -- Rescale from -1.0:+1.0 to 0.0:1.0
    return _noise--/2.0+0.5
end
  function Noise(x,  y)
      return ((__noise(x,y)-0.5)*2)*-1
  end

  function SmoothedNoise1( x,  y)
    corners = ( Noise(x-1, y-1)+Noise(x+1, y-1)+Noise(x-1, y+1)+Noise(x+1, y+1) ) / 16
    sides   = ( Noise(x-1, y)  +Noise(x+1, y)  +Noise(x, y-1)  +Noise(x, y+1) ) /  8
    center  =  Noise(x, y) / 4
    return corners + sides + center
  end

  function InterpolatedNoisei( x,  y)

      integer_X    = math.floor(x)
      fractional_X = x - integer_X

      integer_Y    = math.floor(y)
      fractional_Y = y - integer_Y

      v1 = SmoothedNoise1(integer_X,     integer_Y)
      v2 = SmoothedNoise1(integer_X + 1, integer_Y)
      v3 = SmoothedNoise1(integer_X,     integer_Y + 1)
      v4 = SmoothedNoise1(integer_X + 1, integer_Y + 1)

      i1 = Interpolate(v1 , v2 , fractional_X)
      i2 = Interpolate(v3 , v4 , fractional_X)

      return Interpolate(i1 , i2 , fractional_Y)

  end


  function PerlinNoise_2D( x,  y,n,p)

      total = 0
      p = p--ersistence
      n = n--Number_Of_Octaves -- 1

      for i= 1,n do

          frequency = 2^i
          amplitude = p^i

          total = total + InterpolatedNoisei(x * frequency, y * frequency) * amplitude

      end

      return total

  end
  noise2D = PerlinNoise_2D
  noise=noise2D
function getNoise(x,y,options)

    local options = {
        octaves = (options and options.octave) or 1,
        frequency = (options and options.frequency) or 1,
        amplitude = (options and options.amplitude) or 1,
    }
    
    local n = 0
    local fr = options.frequency
    local oct = options.octaves
    local a = options.amplitude
   -- for i = 1,oct do
        n = noise(x,y,oct,0.5)--x*fr,y*fr)*a
        fr = fr*2
        a = a*0.5
--    end 
log(n)
    return scale(n,{max=oct})
end

Overworld = class:extend("Overworld")
Player = class:extend("Player")

function Player:__init__()
    self.x = 0
    self.y = 0
    self.source = game:getSource("player.png")
    self.w = 16
    self.h = 16
    self._w = 0
    self._h = 0
    self.animation = nil
    self.old = {x=0,y=0}
end

function Player:draw()
    love.graphics.draw(self.source,self.x,self.y,0,self._w,self._h)
end

function Player:update(dt)
    self._w,self._h = resizeImage(self.source,self.w,self.h)
    if self.animation then
        self.animation:update(dt)
        if self.animation.done then
            self.animation = nil
        end
    end
end

function Overworld:__init__()
    self.camera = Camera()
    --self.camera:setFollowStyle("PLATFORMER")
    self.camera.scale = 2
    self.cameraMan = {x=0,y=0}
    
    --noise stuff
    self.worldSize = {
        w = 3,
        h = 3
    }
    self.frequency = 1
    self.amplitude = 1
    self.biomes = {
    --Biomes are:
        --Ice
        --Tundra
        --GrassLand
        --Taiga
        --Woodland
        --Desert
        --SeasonalForest
        --TropicalRainForest
        --Savanna

                    --   coldest     colder     cold          hot                   hotter                 hottest
    --[[dryest ]]     {"Ice",      "Tundra",  "Grassland",  "Desert",             "Desert",              "Desert"},
    --[[dryer  ]]     {"Ice",      "Tundra",  "Grassland",  "Desert",             "Desert",              "Desert"},
    --[[dry    ]]     {"Ice",      "Tundra",  "Woodland",   "Woodland",           "Savanna",             "Savanna"},
    --[[wet    ]]     {"Ice",      "Tundra",  "Taiga",      "Woodland",           "Savanna",             "Savanna"},
    --[[wetter ]]     {"Ice",      "Tundra",  "Taiga",      "SeasonalForest",     "TropicalRainForest",  "TropicalRainForest"},
    --[[wettest]]     {"Ice",      "Tundra",  "Taiga",      "TropicalRainForest", "TropicalRainForest",  "TropicalRainForest"}
    
    }
    
    self.chunkSize = {
        w=3,
        h=3
    }
    self.allChunks = {}
    self.allCurrentChunks = {
        x = {0,1,2},
        y = {0,1,2}--2,3,4}
    }
    self.currentChunks = {}
    self.player = Player:new()
    self.offset = {x=1,y=1,_x=16,_y=16}
    self.chunk = {
        height = 10,
        width = 10
    }
    self.tile = {
        h = 16,
        w = 16
    }
    
    
    self:loadChunks()
    local s = self.allChunks[1][1].tiles[self.chunk.width/2][
        self.chunk.height/2]
        
  --  self.player.x,self.player.y = s._x,s._y
    self.player.x =   (((self.allChunks[1][1].x-1)*self.chunk.width)+1
        )*self.tile.w
   self.player.y = (((self.allChunks[1][1].y-1)*self.chunk.height)+1
        )*self.tile.h
   --self.player.x,self.player.y = s._x,s._y
    
end

function Overworld:loadChunks(x,y)
    
    local x = x or {start=1,en=self.chunkSize.w}
    local y = y or {start=1,en=self.chunkSize.h}
    
    for cx = x.start, x.en do
        self.allChunks[cx] = self.allChunks[cx] or {}
        
        for cy = y.start, y.en do
            if self.allChunks[cx][cy] then
                goto skipTiles
            end
            self.allChunks[cx][cy] = self.allChunks[cx][cy] or {
                x = cx,
                y = cy,
                tiles = {},
                allTiles = {},
                width = self.chunk.height,
                height = self.chunk.width,
                draw = function(self)
                    for x,i in lume.iter(self.allTiles) do
                        love.graphics.draw(game:getSource(i.source),i._x,i._y,0,i._w,i._h)
                    end
                end,
                update = function(self)
                    for x,tile in lume.iter(self.allTiles) do
                        tile._x = tile.ttx*tile.w
                        tile._y = tile.tty*tile.h
                        --log(tostring(tile))
                        tile._w,tile._h = resizeImage(game:getSource(tile.source),tile.w,tile.h)
                    end
                end
            }
            local chunk = self.allChunks[cx][cy]
            local tiles = chunk.tiles
            
            --Check if it has already been loaded
            if tiles[1] then
                --if so skip this
                goto skipTiles
            end
            
            for tx = 1, chunk.width do
                tiles[tx] = tiles[tx] or {}
                
                for ty = 1,chunk.height do
                    local ttx,tty = tx + ((chunk.x-1)*chunk.width),
                                    ty + ((chunk.y-1)*chunk.height)
                    tiles[tx][ty] = tiles[tx][ty] or self:generateTerrain(
                        ttx,
                        tty
                    )
                    local tile = tiles[tx][ty]
                    tile.ttx,tile.tty = ttx,tty
                    tile._x = ttx*tile.w
                    tile._y = tty*tile.h
                    table.insert(chunk.allTiles,tile)
                end
            
            end
            
            ::skipTiles::
        end
    end
end

function Overworld:drawChunks()
    for _,xval in ipairs(self.allCurrentChunks.x) do
        for _y,yval in ipairs(self.allCurrentChunks.y) do
            if not self.allChunks[xval] or not self.allChunks[xval][yval] then
            else
                local chunk = self.allChunks[xval][yval]
                chunk:draw()
            end
        end
    end
end

function Overworld:draw()
    self.camera:attach()
    self:drawChunks()
    self.player:draw()
    self.camera:detach()
    self.camera:draw()
    paddy.draw()
end

function Overworld:update(dt)
    self.player:update(dt)
    self.camera:follow(self.player.x,self.player.y)
    self.camera:update(dt)
    paddy.update(dt)
    local speed = self.tile.w--100*dt
    self.player.old.x = self.player._x
    self.player.old.y = self.player._y
    if not self.player.animation then
    if isDown("down") then
        self.player._y = self.player.y + speed
        self.offset._y = self.offset._y + speed
    elseif isDown("up") then
        self.player._y = self.player.y - speed
        self.offset._y = self.offset._y - speed
    elseif isDown("left") then
        self.player._x = self.player.x - speed
        self.offset._x = self.offset._x - speed
    elseif isDown("right") then
        self.player._x = self.player.x + speed
        self.offset._x = self.offset._x + speed
    end
    self.player._y = self.player._y or self.player.y
    self.player._x = self.player._x or self.player.x
    if self.player._x ~= self.player.x or self.player._y ~= self.player.y then
        self.player.animation = Animation:new({x=self.player._x,y=self.player._y,d=.025})
        self.player.animation:start(self.player)
    end
    end
    local o = self.offset
    if self.offset._x > (self.chunk.width)*(self.tile.w) then --+self.offset.x) then
    log(o)
    log( (self.chunk.width)*(self.tile.w+self.offset.x))
    log("ch..")
        self.offset._x = 16
        self.offset.x = self.offset.x + 1
        local a = self.allCurrentChunks.x
        local aa = {}
        for c,i in lume.iter(a) do
            aa[c] = i+1
        end
        self.allCurrentChunks.x = aa
        
    elseif self.offset._x <= 0 then--self.chunk.width*self.tile.w*-1 then
        self.offset._x = 16*self.chunk.width
        self.offset.x = self.offset.x - 1
        local a = self.allCurrentChunks.x
        local aa = {}
        for c,i in lume.iter(a) do
            aa[c] = i-1
        end
        self.allCurrentChunks.x = aa
    end
    if self.offset._y > self.chunk.height*self.tile.h then
        self.offset._y = 16
        self.offset.y = self.offset.y + 1
        local a = self.allCurrentChunks.y
        local aa = {}
        for c,i in lume.iter(a) do
            aa[c] = i+1
        end
        self.allCurrentChunks.y = aa
        
    elseif self.offset._y <= 0 then--self.chunk.width*self.tile.h*-1 then
        self.offset._y = self.chunk.height*self.tile.h
        self.offset.y = self.offset.y - 1
        local a = self.allCurrentChunks.y
        local aa = {}
        for c,i in lume.iter(a) do
            aa[c] = i-1
        end
        self.allCurrentChunks.y = aa
    end
    if self.offset.x > 5 then
     end --  xadd =
    for _,xval in ipairs(self.allCurrentChunks.x) do
        --[[if self.allChunks[xval-5] then
            self.allChunks[xval-5] = nil
        end
        if self.allChunks[xval+5] then
            self.allChunks[xval+5] = nil
        end]]
        for _y,yval in ipairs(self.allCurrentChunks.y) do
            if not self.allChunks[xval] or not self.allChunks[xval][yval] then
                self:loadChunks({start=xval,en=xval},{start=yval,en=yval})
            end
            local chunk = self.allChunks[xval][yval]
            chunk:update(dt)
        end
    end
    self.player.old.tile = self.player.tile
    self.player.tile = self.allChunks[o.x][o.y]
    local k = self.player.tile.tiles
    if o._x/self.tile.w > self.chunk.width then
    --    o._x = self.tile.w 
    log(self.player.old.tile)
    self.player.tile = self.player.old.tile
        self.playjer.x = self.player.tile.ttx*self.tile.w
        self.player.animation = false
    else
        self.player.tile = self.player.tile.tiles[o._x/self.tile.w]
        if not self.player.tile then
        log(o)
        log(o._x/16)
        for i,o in lume.iter(k) do
            log(i)
        end
        log("end")
    end
    self.player.tile = self.player.tile[o._y/self.tile.h]
    --self.player.tile.source = "player.png"
    end
    
    
    
    
end

function Overworld:generateTerrain(x, y)
    --x, y are scaled
    local s = love.math.random() 
    x = (x+s)/(self.worldSize.w)
    y = (y+s)/(self.worldSize.h)
    F = self.frequency
    A = self.amplitude
    local elevation = self:getHeight(x,y)
    local temperature = self:getTemperature(x,y,{height=elevation})--scale(noise2D(x*F,y*F)*A)
    local moisture = self:getMoisture(x,y,{height=elevation})--scale(love.math.noise(x*F,y*F, 0)*A)
    local tile = self:getBiome(elevation, temperature, moisture)
    tile.w, tile.h = self.tile.w, self.tile.h
    --log(lume.serialiqze(tile))
    
    tile.height = elevation
    tile.moisture = moisture
    tile.temperature = temperature
    tile.temp = tile.temperature
    
    tile.source = "biomes/"..lume.randomchoice(tile.sources).."/"..tile.height.name..".png"
    tile._w,tile._h = resizeImage(game:getSource(tile.source),tile.w,tile.h)
    return tile
end


function Overworld:getHeight(x,y)
    local n = getNoise(x,y,mapGen.hieghts)
    for i,height in ipairs(mapGen.heights) do
        height.pos = i
        if n < height.value then
            local v = lume.copy(height)
            v.realValue = n
            return v
        end
    end
end


function Overworld:getTemperature(x,y,t)
    local n = getNoise(x,y,mapGen.temperatures)
    t = t or {height={}}
    if t.height.name == "Grass" then
        n = n-0.1*t.height.realValue
    elseif t.height.name == "Forest" then
        n = n-0.3*t.height.realValue
    elseif t.height.name == "Rock" then
        n = n-0.3*t.height.realValue
    elseif t.height == "Snow" then
        n = n-0.4*t,height.realValue
    end
    for i,temp in ipairs(mapGen.temperatures) do
        temp.pos = i
        if n < temp.value then
            local v = lume.copy(temp)
            v.realValue = n
            return v
        end
    end
end

function Overworld:getMoisture(x,y,t)
    local n = getNoise(x,y,mapGen.moisture)
    t = t or {height={}}
    if t.height.name == "DeepWater" then
        n = n+0.8*t.height.realValue
    elseif t.height.name == "ShallowWater" then
        n = n+0.3*t.height.realValue
    elseif t.height.name == "Sand" then
        n = n+0.1*t.height.realValue
    elseif t.height == "Grass" then
        n = n+0.25*t,height.realValue
    end
    if n >=1 then n = 0.99 end
    for i,moisture in ipairs(mapGen.moisture) do
        moisture.pos = i
        if n < moisture.value then
            local v = lume.copy(moisture)
            v.realValue = n
            return v
        end
    end
end

function Overworld:getBiome(elevation, temperature, moisture)
    local ev = elevation.pos
    local temp = temperature.pos
    local m = moisture.pos
    local _biome = self.biomes[m][temp]
    if elevation.name == "DeepWater" or elevation.name == "ShallowWater" and
        moisture.realValue > mapGen.moisture[4].value then
           -- _biome = "Ocean"
    end


    local biome = Biomes[_biome]
    biome.name = _biome
    return lume.copy(biome)
end


return Overworld