local noise2D = noise
local love = love
local timer = love.timer
local lume,math,game = lume,math,game
local store = store
local table,pairs,ipairs = table,pairs,ipairs

--table.insert = function(t,i) t[#t+1] = i end
local getRound, gooi = getRound, gooi

TT = 20
doDebug = nil
local mapGen = mapGen
mapGen.heights.islands = false
local function isDown(m) 
    return self.paddy:isDown(m)
end

local _Path = class:extend("_Path")
function _Path:__init__(x,y)
    self.x = x
    self.y = y
end

function _Path:getX()
    return self.x
end

function _Path:getY()
    return self.y
end

function _Path:getPos()
    return self.x, self.y
end

local function scale(_noise)
    -- Rescale from -1.0:+1.0 to 0.0:1.0
    return _noise--/2.0+0.5
end
local function __scale(_noise)
    -- Rescale from -1.0:+1.0 to 0.0:1.0
    return _noise--/2.0+0.5
end

local sc = function(n) return n end
local function getNoise(x,y,options)
    local options = {
        octaves = (options and options.octaves) or 1,
        frequency = (options and options.frequency) or 1,
        amplitude = (options and options.amplitude) or 1,
        persistence = (options and options.persistence) or 0.5,
        power = (options and (options.power or options.exponent)) or 1,
        scale = (options and options.scale) or sc,
        parent = (options and options.parent) or {_noise=Simplex:new()},
    }
    
    local n = 0
    local fr = options.frequency
    local oct = options.octaves
    local a = options.amplitude
    local p = options.persistence
    local pow = options.power
    local scale = options.scale
    
    local _noise = options.parent._noise
    --local noise = function (x,y)
    --    return _noise:get(x,y)--__scale(_noise:get(x,y))
    --end
    
    for i = 1,oct do
        n = n+scale(_noise:get(x*fr,y*fr))*a
        fr = fr*2
        a = a*p
    end

    local n = (pow~=1 and  math.pow(scale(n,{max=oct}),pow)) or scale(n,{max=oct})
    if n>1 then n=0.999999 end
    
 
    return n--/2+0.5
end

local function getSeed(s)
    if not s then return os.time() end
    if type(s) == "table" then
        return lume.choice(s)
    else
        return s
    end
end

Overworld = class:extend("Overworld")

function Overworld:scale(x,y)
    local s = 0-self.rahndom
    return ((x+s)/(self.worldSize.w)),--+s/self.worldSize.w,
    ((y+s)/(self.worldSize.h))--+s/self.worldSize.h
end

function Overworld:scaleCoords(x,y)
    local s = self.random
    
   -- z
 --   zx=
    local xx = (x)/(self.worldSize.w)--s/self.worldSize.h
    local yy = (y)/(self.worldSize.h)
    return xx,yy
end
local function playerPosIsOpen(x,y)
    return posIsOpen(x,y,true)
end

function Overworld:lightCallback(fov,x,y)
    local tile = self.tiles[x] and self.tiles[y]
    if tile then
        return true
    end
    return false
end

function Overworld:computeCallback(x, y, r, v)
    local tile = self.tiles[x] and self.tiles[y]
    if tile then
        self:makeTileDarker(tile)
    end
end

function Overworld:isWalkalble(x,y)
    local t = self.tiles[x] and self.tiles[x][y]
    if not t then
        return false
    else
        return true
    end
end

function Overworld:lightCallback(...)
    return lightCallback(...)
end

function Overworld.lightCallback(...)
    return lightCallback(...)
end

function Overworld:findPath(obj,x,y)
    local obj = obj
    local x = x
    local y = y
    if type(obj) ~= "table" then
        x = obj
        y = x
        obj = y
    end
    x=x
    y=y
    
    if type(x) == "table" then
        x, y = x.x, x.y
    end
    

    local _x = (obj.tile and obj.tile.ttx) or obj.x
    local _y = (obj.tile and obj.tile.tty) or obj.y
    --w = #self.allCurrentChunks.x*self.chunk.width
    --h = #self.allCurrentChunks.y*self.chunk.height
    local function check(x,y)
        return self:isWalkable(x,y)
    end
    
    local path = {}
    local function buildPath(x,y)
        table.insert(path,_Path:new(x,y))
    end
    
    goal = {x=x,y=y}
    start = {x=_x,y=_y}
    local pth = rot.Path.AStar(goal.x,goal.y,check)
    pth:compute(start.x,start.y,buildPath)
    return path
end

function Overworld:findPathTo(...)
    return self:findPath(...)
end

mPlayer = class:extend("mPlayer")

function mPlayer:__init__()
    self.x = 0
    self.y = 0
    self.source = game:getSource("player.png")
    self.w = 16
    self.h = 16
    self._w = 0
    self._h = 0
    self.animation = nil
    self.old = {x=0,y=0}
end

function mPlayer:draw()
    love.graphics.draw(self.source,self.x,self.y,0,self._w,self._h)
end

function mPlayer:update(dt)
    self._w,self._h = resizeImage(self.source,self.w,self.h)
    if self.animation then
        self.animation:update(dt)
        if self.animation.done then
            self.animation = nil
        end
    end
end

function Overworld:isWalkable(x,y)
    local t = self.tiles[x] and self.tiles[x][y]
    if not t then return false end
    if t.isWater then return false end
    return true
end

function Overworld:fov(x,y,radius)
    local fu = function(...)
        return self:computeCallback(...)
    end
    return self._fov:compute(x,y,radius,fu)
end

zz={zx=1,zy=1,x=0,y=0}

function Overworld:destroy()
    gooi.removeComponent(self.debugPanel)
end

function Overworld:__init__(kwargs)
    local kwargs = kwargs or {}
    self.fpsGraph = Graph:new()
    self.graph = self.fpsGraph
    
    self.makeMiniMap = self.makeBabyMap
    self._text = gooi.newText({text=""})
    self.debugPanel = gooi.newPanel({layout="grid 1x5",w=W(),h=H()/10,y=0,x=0}):
        setColspan(1,1,4):
        
        add(
            self._text,
            gooi.newButton({text="Submit"}):
            onRelease(function()
                _G["self"] = self
                loadstring(self._text:getText())()
                local s = self
                _G["self"] = nil
                local self = s
                self._text:setText("")
                assert(self._text:getText()=="")
            end)
        )
    self.camera = Camera()
    self.camera:setFollowStyle("LOCKON")
    self.camera.scale = 0.99
    self.cameraMan = {x=0,y=0}
    self.timer = Timer.new()
    kwargs.parent = self
    self.paddy = Paddy:new(kwargs)
    self.usePaddy = kwargs.usePaddy or true
    self.colorTiles = {}
    --use: self.fov:compute(x,y,radius,compute callback)
    local fi = function(fov,x,y) 
        return self:lightCallback(fov,x,y) 
    end
    local tr = function(fov,x,y)
        return true
    end
    self._fov = rot.FOV.Precise:new(fi, {topology=4})
    self._terrainFov = rot.FOV.Precise:new(tr, {topology=4})
    
    
    
    --noise stuff
    sself = self
    self.seed = getSeed(9)--kwargs.seed)
    math.randomseed(self.seed)
    self._noise = Simplex()
    self.random = math.random()*100
    self.worldSize = {
        w = 15,--for reals make it 225
        h = 15,
        riverCount = math.random(1000,1550),
        tmpData = {},
        data = {},
        landMasses = {}
    }
    self.frequency = 1
    self.amplitude = 1
    self.biomes = lume.copy(mapGen.biomes)
    
    self.chunkSize = {
        w=3,
        h=3
    }
    self.allChunks = {}
    self.allTiles = {}
    self.colorTiles = {}
    self.camps = {}
    --tiles generated at a time
    self.genRange = kwargs.genRange or 5
    if type(self.genRange) == "number" then
        self.genRange = {x=self.genRange,y=self.genRange}
    elseif not self.genRange.x then
        self.genRange = {x=self.genRange[1],y=self.genRange[2]}
    end
    
    self.allCurrentChunks = {
        x = {0},
        y = {0}
    }
    for t = 1,(self.genRange.x-1)/2 do
        table.insert(self.allCurrentChunks.x,-t)
        table.insert(self.allCurrentChunks.x,t)
    end
    for t = 1,(self.genRange.y-1)/2 do
        table.insert(self.allCurrentChunks.y,-t)
        table.insert(self.allCurrentChunks.y,t)
    end
    
    table.sort(self.allCurrentChunks.x)
    table.sort(self.allCurrentChunks.y)
    self.currentChunks = {}
    self.camp = kwargs.player or (kwargs.super and kwargs) or mPlayer:new()
    self:addCamp(self.camp)
    self.offset = {x=1,y=1,_x=16,_y=16}
    self.chunk = {
        height = 10,
        width = 10
    }
    self.tile = {
        h = 16,
        w = 16
    }
    
    for x,i in pairs(mapGen) do
        i.parent = self
    end
    
    --self:initRivers()
    self:loadChunks()
    local s = self.allChunks[1][1].tiles[self.chunk.width/2][
        self.chunk.height/2]
        
  --  self.camp.x,self.camp.y = s._x,s._y
    self.camp.x =   (((self.allChunks[1][1].x-1)*self.chunk.width)+1
        )*self.tile.w
   self.camp.y = (((self.allChunks[1][1].y-1)*self.chunk.height)+1
        )*self.tile.h
   -- self.camp.x =   ((((goTo.x-1))+1)*self.tile.w) self.camp.y = ((((goTo.y-1))+1)*self.tile.h)
   --self.camp.x,self.camp.y = s._x,s._y
end

function Overworld:addCamp(camp)
    camp.map = self
    camp.overworld = self
    table.insert(self.camps,camp)
    camp.id = tostring(self.camp)
    self.camps[camp.id] = camp
    return camp
end

function Overworld:mousereleased(x,y,button)
    local trash = self.pop and self.pop:mousereleased(x,y,button)
    gooi.released()
end

function Overworld:mousepressed(x, y, button)
    local trash = self.pop and self.pop:mousepressed(x,y,button)
    gooi.pressed()
end

function Overworld:touchreleased(id, x, y, dx, dy, pressure)
    local trash = self.pop and self.pop:touchreleased(id,x,y,dx,dy,pressure)
    if trash then
        self.buttonPressed = true
    end
    if not self.buttonPressed then
        ttx = x
        tty = y
    else
        self.buttonPressed = false
        return
    end
    x,y = self.camera:toWorldCoords(x,y)
    local sx,sy = self:convertPixelToTile(x,y)
    sx = math.floor(sx)
    sy = math.floor(sy)
    local tile = self:getTileWithPos(sx,sy)
    
    if tile then
   --     self.cameraMan = {x=x,y=y}
   
        local target = tile.unit
        self.tmpselected = target
        local unit = self.camp.selected
        if tile.unit then
            self.tmpselected = tile.unit
            self:popUp(1,tile.unit)
        else
            if self.pop then
                self.pop:destroy()
                self.pop = nil
            else
                self.camp:moveTo(tile)
            end
        end
    else
        if self.pop then self.pop:destroy() end
        self.pop = nil
    end
end

function Overworld:convertPixelToTile(x,y)
    return x/self.tile.w,y/self.tile.h
end

function Overworld:convertTileToPixel(x,y)
    return x*self.tile.w,y*self.tile.h
end

function Overworld:getTileWithPos(x,y)
    if self.tiles[x] and self.tiles[x][y] then
        return self.tiles[x][y]
    end
end

function Overworld:popUp(num, obj)
    self._popUp = {num,obj}
    if self.pop then
        self.pop:destroy()
    end
    --log(obj.x..", "..obj._y)
    local sw = 8
    local sh = 2
    local xx, yy = self.camera:toCameraCoords(obj.x,obj.y)
    log(xx..",, "..yy)
   -- local yy= 16--00--yy-100
    yy = yy-(obj.h*5)
    if num==1 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"EQUIP","FEED","ITEMS","BACK"},
            onRelease=function(t)
                self.buttonpressed = true
                if t=="ITEMS" then
                    if self.pop then self.pop:destroy() end
                    self:popUp(3,obj)
                elseif t=="EQUIP" then
                    if self.pop then self.pop:destroy() end
                    self:popUp(2,obj)
                elseif t=="FEED" then
                    if self.pop then self.pop:destroy() end
                    self:popUp(2,obj)
                elseif t=="BACK" then
                    if self.pop then self.pop:destroy() end
                    self.pop = nil
                end
            end
        })
        self.pop = pop
    elseif num==2 then
        local data = player.itemTypes
        local i = obj.inventory
        
        for name, list in ipairs({}) do--player:iterInventory() do
            if ALL_ITEMS[name].isEdible then
                table.insert(data,name)
            end
        end
        table.sort(data, function(a, b) return i[a] end)
        
        local pop = GiverTaker:new({
            data = data,
            x=xx,
            y=yy,
            w=obj.w*sw+20,
            h=obj.h*sh+20,
            inventory = obj.inventory,
            onRelease = function(val,t)
                self.buttonpressed = true
                local lim = player.heldItems[t]
                if val<0 then
                    if self.dont then
                        self.dont = nil
                        return
                    end
                    player:removeItemFromUnit(t,obj)
                elseif val>0 then
                    if lim >= #player.inventory[t] then
                        self.pop.dont = true
                        self.pop.spinner:changeValue(val*-1)
                        return false
                    end
                    player:addItemToUnit(t,obj)
                end
             --   self.pop:destroy()
               -- self:popUp(2,obj)
            end
        })
        self.pop = pop
    end
    if self.pop then
        self.pop.gooi = gooi
    end
end

function Overworld:rePopUp()
    self.camera:update(0.1)
    if not self.pop then
        return
    end
    self.pop:destroy()
    self:popUp(self._popUp[1],self._popUp[2])
end

function Overworld:loadCamp()
    self:scaleMap(20)
    self:update(0,1)
    local units = {
        units = {}, enemies = {}, w=20,h=20
    }
    for u = 1,15 do
        table.insert(units.units,Unit:new())
    end
    self.camp = ZoomedCamp:new(units)
    self:makeBabyMap(10,self.camp)
    local continue = self.camp:placeUnits()
    if continue then
        GSS(self.camp)
        return true
    else
        self.camp = nil
        self:scaleMap(1/20)
        return false
    end
end

function Overworld:loadBattle()
    --self.timer:after(1, function() self.camera:fade(2.5,{1,0,111,0}) end)
    self:scaleMap(20)
    log("???????????????donut")
    self:update(0,1)
    local units = {
        units = {}, enemies = {}
    }
    for u = 1,2 do
        table.insert(units.units,Unit:new())
    end
    for e = 1,2 do
        table.insert(units.enemies,Unit:new())
    end
    self.battle = BattleScene(units,false,self.camp)
    self.battle.__old = self
    self:makeBabyMap(10,self.battle)
    self.battle:placeUnits()
    
    log("!!!!!!!!!!!!!!!breakout")
    doB = true
    
    GSS(self.battle)
    --self.timer:after(1, function() GSS(self.battle) end )
end

function Overworld:shakeloadBattle()
    self.battleLoaded = true
    ----intensity,dur,freq
    self.camera:shake(51,1,60)--fade(1,colors.red)
    self.timer:after(1,function() self:_loadBattle() end)
end


function Overworld:makeBabyMap(radius, _map)
    local radius = radius or 10
    local r = radius+1
    local pl = self.camp
    local t = self.camp.tile
    local tiles = self.worldSize.data
    local map = _map or GridMap:new()
    
    for xk,yk in ipairs(getRound(radius)) do
        local x, y = yk[1],yk[2]
        map:addTile(tiles[t.ttx+x] and tiles[t.ttx+x][t.tty+y], x+r,y+r)
    end
    
    map:load()
    return map
end


function Overworld:reset(l)
    local load = l or true
    if l == false then load = false end
    
    self.allChunks = {}
    self.allCurrentChunks = {
        x = {0,1,2},
        y = {0,1,2}--2,3,4}
    }
    self.currentChunks = {}
    if load then
        self:loadChunks()
    end
    self.worldSize.data = {}
    self.worldSize.landMasses = {}
    self.tiles = {}
    self.blueNoise = {}
end

--does not work!!--????
function Overworld:generateTrees(x,y,tile) if 3 then return end 
    local r = tile.vegetation
    local max = 0
    blueNoise = blueNoise or {}
    for rX = x-r,x+r do
        blueNoise[rX] = blueNoise[rX] or {}
        for rY = y-r, y+r do
            local vx,vy = self:scaleCoords(rX,rY)
            blueNoise[rX][rY] = blueNoise[rX][rY] or getNoise(vx,vy,mapGen.trees)
            local n = blueNoise[rX][rY]
            if n>max then
                 log("at "..rX..", "..rY.." n is "..n)
                max = n
            end
        end
    end
    if blueNoise[x][y] == max then-- not tile.isWater then
        table.insert(tile.children,Biomes.Tree:new(tile))
        tile.source ="tree.png"
    end
end

function Overworld:tileIsActive(tile)
    return tile.updateID == self.updateID
end

function Overworld:initRivers()
    local v = self.worldSize.tmpData
    for c = 1, self.worldSize.riverCount do
        local notThere = true
        local maxDepth = nil
        local max = 5
        repeat
            max = max - 1
            if max <= 0 then
                maxDepth = true
             --   goto continue
            end
            local xx = math.random(1,self.worldSize.w*self.chunkSize.w*self.tile.w)
            local yy = math.random(1,self.worldSize.h*self.chunkSize.h*self.tile.h)
            local h = self:getHeight(self:scale(xx,yy))
            local vv = math.random(700,890)/1000
            if h.realValue < vv  then
                goto continue
            end
            for x,c in lume.iter(getRound(5)) do
                if v[xx+c[1]] and v[xx+c[1]][yy+c[2]] then
                    goto continue
                end
            end
            if not v[xx] then
                v[xx] = {}
                v[xx][yy] = {isRiverSource=true}
                notThere = false
            elseif not v[xx][yy] then
                v[xx][yy] = {isRiverSource=true}
                notThere = false
                goTo = {x=xx,y=yy}
            end
            ::continue::
        until not notThere or maxDepth
    end
end

function Overworld:loadChunks(x,y,px,py,llog)
    --self:initRivers()
    
    local px = px or 1
    local py = py or 1
    local x = x or {start=1,en=self.chunkSize.w}
    local y = y or {start=1,en=self.chunkSize.h}
    self.tiles = self.worldSize.data

    for cx = x.start, x.en do
        self.allChunks[cx] = self.allChunks[cx] or {}
        
        for cy = y.start, y.en do
            if self.allChunks[cx][cy] then
                goto skipTiles
            end
            
            self.allChunks[cx][cy] = self.allChunks[cx][cy] or {
                x = cx,
                y = cy,
                tiles = {},
                allTiles = {},
                width = self.chunk.height,
                height = self.chunk.width,
                parent = self,
                draw = function(self)
                    for x,i in lume.iter(self.allTiles) do
                        love.graphics.draw(game:getSource(i.source),i._x,i._y,0,i._w,i._h)
                        for _,ii in ipairs(i.children) do
                            ii:draw()
                        end
                    end
                end,
                update = function(self,dt)
                    for x,tile in lume.iter(self.allTiles) do
                        tile._x = tile.ttx*tile.w
                        tile._y = tile.tty*tile.h
                        --log(tostring(tile))
                        tile._w,tile._h = resizeImage(game:getSource(tile.source),
                            tile.w,tile.h)
                        tile.updateID = self.parent.updateID
                        for _,i in ipairs(tile.children) do
                            i:update(dt)
                        end
                    end
                end
            }
            local chunk = self.allChunks[cx][cy]
            local tiles = chunk.tiles
            
            --Check if it has already been loaded
            if tiles[1] then
                --if so skip this
                goto skipTiles
            end
            
            for tx = px, chunk.width+(px-1) do
                tiles[tx] = tiles[tx] or {}
                
                for ty = py,chunk.height+(py-1) do
                    local ttx,tty = tx + ((chunk.x-1)*chunk.width),
                                    ty + ((chunk.y-1)*chunk.height)
                    tiles[tx][ty] = (tiles[tx] and tiles[tx][ty]) or 
                    (self.tiles[ttx] and self.tiles[ttx][tty]) or 
                    self:generateTerrain(
                        ttx,
                        tty
                    )
                    local tile = tiles[tx][ty]
                    --these are children that should be drawn
                   -- tile.children = {}
                    self:generateTrees(ttx,tty,tile)
                    
                    tile.ttx,tile.tty = ttx,tty
                    tile.isTile = true
                    self.worldSize.data[ttx] = self.worldSize.data[ttx] or {}
                    self.worldSize.data[ttx][tty] = tile
                    
                    tile.x = tx
                    tile.y = ty
                    
                    tile._x = ttx*tile.w
                    tile._y = tty*tile.h
                    tile.chunkx = cx
                    tile.chunky = cy
                    
                    tile.id = ttx..", "..tty--lume.uuid()
                    local map = self
                    tile.getAdjacentTiles = function(self)
                        return map:getAdjacentTiles(self.ttx,self.tty)
                    end
                  --  if tile.isRiver then tile.ttx=100000 end
                    table.insert(chunk.allTiles,tile)
                    table.insert(self.allTiles,tile)
                end
            
            end
            
            --tiles[1][1].source="red.png"
            ::skipTiles::
        end
    end
  --  self.allChunks[1][1].tiles[1][1].source = "player_down.png"
end

function Overworld:getAdjacentTiles(x,y)
    local tiles = {}
    for _,x in lume.iter(getRound(1)) do
        local tile = self.tiles[x+c[1]] and self.tiles[x+c[1]][y+c[2]]
        if tile then
            table.insert(tiles,tile)
        end
    end
    assert(#tiles~=0,"Couldn't get adjacent tiles.")
    return tiles
end

function Overworld:drawChunks()
    local xval, yval
    for _ = 1, #self.allCurrentChunks.x do
        xval = self.allCurrentChunks.x[_]
        for _y = 1, #self.allCurrentChunks.y do
            yval = self.allCurrentChunks.y[_y]
            if not self.allChunks[xval] or not self.allChunks[xval][yval] then
            else
                local chunk = self.allChunks[xval][yval]
                chunk:draw()
            end
        end
    end
end

function Overworld:draw()
    self.camera:attach()
    self:drawChunks()
    for x,i in lume.iter(self.colorTiles) do
        local t = game:get(x)
        if self:tileIsActive(t) then
            self:_colorTile(t,i)
        end
    end
    self.camp:draw()
    self.camera:detach()
    self.camera:draw()
    local trash = self.usePaddy and self.paddy:draw()
    self.camp:draw()
    local trash = (self.pop and self.pop:draw()) or gooi.draw()
    self.graph:draw(30,H()-120)
end

function Overworld:reloadAllCurrentChunks(x,y)
    local x,y = x or 0, y or 0
    self.allCurrentChunks = {
        x = {x},
        y = {y}
    }
    for t = 1,(self.genRange.x-1)/2 do
        table.insert(self.allCurrentChunks.x,-t+x)
        table.insert(self.allCurrentChunks.x,t+x)
    end
    for t = 1,(self.genRange.y-1)/2 do
        table.insert(self.allCurrentChunks.y,-t+y)
        table.insert(self.allCurrentChunks.y,t+y)
    end
    
    table.sort(self.allCurrentChunks.x)
    table.sort(self.allCurrentChunks.y)
end

function Overworld:movePlayerToTile(x,y)
    local x = x
    local y = y
    local tile = (type(x)=="table" and x) or self:getTile(x,y)
    x,y = tile.ttx,tile.tty
    assert(not tile.fromBattleScene)
    
    self.camp.tile.unit = nil
    self.camp.tile = tile
    tile.unit = self.camp
    
    sx = math.floor((x-1)/10)+1
    sy = math.floor((y-1)/10)+1
    if not self.camp.tile.chunkx then
        self:loadChunks({start=sx,en=sx},{start=sy,en=sy})
    end
    self:reloadAllCurrentChunks(sx,sy)
    self.offset._x=tile.x*tile.w
    self.offset._y = tile.y*tile.h
    self.camp.x=tile.ttx*tile.w
    self.camp.y = tile.tty*tile.h
    self.camp._x = nil
    self.camp._y = nil

    self.offset.x = sx
    self.offset.y = sy
end

function Overworld:teleportPlayer(...)
    return self:movePlayerToTile(...)
end

function Overworld:getScaledPos(x,y,_scaleX,_scaleY)

        local scaleX, scaleY = _scaleX or 1
        local scaleY = _scaleY or scaleX
        local x, y = x,y
        if type(x)  == "table" then
            x,y = x.ttx or x.x, x,tty.y
            scaleX = y or 1
            scaleY = _scaleX or scaleX
        end
        if type(scaleX)=="table" then
            local vx = scaleX
            scaleX = vx.x
            scaleY = vx.y
        end

        ssy = self.worldSize.h*scaleY
        ssx = self.worldSize.w*scaleX
    
        --getting chunk where the tile belongs to
        local ox,oy = self.worldSize.w,self.worldSize.h
        ox = (ssx/ox)-1
        oy= (ssy/oy)-1

        
        sx = math.floor(x+x*ox)
        sy=math.floor(y+y*oy)
        
        return sx,sy
end

function Overworld:scaleMap(scaleX,scaleY)
   -- self:reset(false)
    local scaleX, scaleY = scaleX or 1
    local scaleY = scaleY or scaleX
    if scaleX == 0 and scaleY == 0 then
        --Already scaled
        return
    elseif scaleX == 1 and scaleY == 1 then
        --Already scaled
        return
    else
        local ssy = self.worldSize.h*scaleY
        local ssx = self.worldSize.w*scaleX
    
        local t = self.camp.tile 
        local tile = t
        local ox,oy = self.worldSize.w,self.worldSize.h
        ox = (ssx/ox)-1
        oy= (ssy/oy)-1

        self.worldSize.h = ssy
        self.worldSize.w = ssx
        local sx = math.floor(t.ttx+t.ttx*ox)
        local sy=math.floor(t.tty+t.tty*oy)
        self.offset._x=0
        self.offset._y=0
        self:reset(false)
        ox = self.worldSize.w/ox
        oy = self.worldSize.h/ox
        local oox = math.floor((sx-1)/10)+1
        local ooy = math.floor((sy-1)/10)+1
        self.camp.tile = self.worldSize.data[sx] and self.worldSize.data[sx][sy]
        
        if not self.camp.tile then
            self:loadChunks({start=oox,en=oox},{start=ooy,en=ooy})--),t.x,t.y)
            self.offset.x = oox--self.camp.tile.chunkx
   
        end
   
        
        self.camp.tile = self.worldSize.data[sx] and self.worldSize.data[sx][sy]
       --[[ l=self.allChunks[1]
        l=l[1]
        l=l.tiles[1][10].source]]
        self.allCurrentChunks.x = {oox-2,oox-1,oox,oox+1,oox+2}
        self.allCurrentChunks.y = {ooy-2,ooy-1,ooy,ooy+1,ooy+2}

        assert(self.camp.tile, "No Tile! at "..sx.." ,"..sy)
        tty=t.tty
        ttx=t.ttx

        local ttt=self.camp.tile
    
        local o = self.offset
        
        self.offset.x = ttt.chunkx
        self.offset.y = ttt.chunky
        self.offset._x = self.camp.tile.x*self.tile.w
        self.offset._y = self.camp.tile.y*self.tile.h
        self.camp.x = self.camp.tile.ttx*self.tile.w
        self.camp.y = self.camp.tile.tty*self.tile.h
        self.camp._x = self.camp.tile.ttx*self.tile.w
        self.camp._y = self.camp.tile.tty*self.tile.h
        --log("chunk1: "..o.x..", "..o.y)
        
        self.tiles = self.worldSize.data
    end
end

function Overworld:zoomIn(_scale,steps,time,func)
    --steps should be bigger than (scale/2)
    
    local time, func = time, func
    if type(time) == "function" then
        time = func
        func = time
    end
    
    local steps = steps or 1
    if steps == _scale then
        steps = steps-.5
    end
    local scale = (_scale/(steps or 1))
    if scale<1 then
        scale = 1+scale
    end
    local t = self.camp.tile
    self.zoomer = {
        oldTile = {x=t.x,y=t.y,ttx=t.ttx,tty=t.tty},
        addedScale = _scale,
        origionalScale = 1,
        realScale = 1,
        scale = scale,
        steps = steps,
        duration = time or 3,
        timePerStep = (time or 3)/steps,
        tmpStep = 0,
        stepsTaken = 0,
        Tscale=0,
        oldScale=0,
        anim = Animation:new({Tscale=_scale-1,d=(time or 3)}),
        onFinish = func,
    }
    self.zoomer.anim:start(self.zoomer)
end

function Overworld:update(dt,_loaded,move)
if track then ProFi:start() end
    observeGlobals()
    self.updateID = lume.uuid()

    gooi.update(dt)
    local trash = (self.pop and self.pop:update(dt))
    local playerSpeed = 0.0000000000025
    local data = self.worldSize.data
    local moveRight = move
    self.tiles = data
    
    self.camp:update(dt)
    if self.camp.tile then
        self.camp.tile.unit = nil
    end
    local function isDown(k)
        if not _loaded and self.usePaddy then
            return self.paddy:isDown(k) 
        end
    end
    self.camera:follow(self.camp.x,self.camp.y)
    self.camera:update(dt)
    self.timer:update(dt)
    if not _loaded then
    self.paddy:update(dt) end
    local speed = self.tile.w--100*dt
    
    if not self.camp._oldPos or self.camp._oldPos.x ~= self.camp.x or
      self.camp._oldPos.y ~= self.camp.y then
        self:rePopUp()
    end
        
    self.camp._oldPos = {x=self.camp.x,y=self.camp.y}
    self.camp.old.x = self.camp._x
    self.camp.old.y = self.camp._y
    if not self.camp.animation and not self.camp.path then
        if animm then
            animm:update(dt)
        end
        if self.zoomer and not _loaded then
            local zoom = self.zoomer
            self.zoomer.anim:update(dt)
            -- self.zoomer.totalScale = 
            self.zoomer.TTscale =  self.zoomer.Tscale-self.zoomer.oldScale
            local  r=self.zoomer.realScale
            self.zoomer.origionalScale = self.zoomer.origionalScale/(1+self.zoomer.TTscale)
            self.zoomer.realScale = 1*(1+self.zoomer.Tscale)
            local newr = self.zoomer.realScale
            self:scaleMap(1/r)--self.zoomer.origionalScale)---1/self.zoomer.Tscale)
            self.camp.tile = self:getTile(zoom.oldTile.ttx, zoom.oldTile.tty)
            --data[zoom.oldTile.ttx][zoom.oldTile.tty]
            
            self:scaleMap(self.zoomer.realScale)--Tscale)
            self:update(0,true)
            self.zoomer.oldScale = self.zoomer.Tscale

        if self.zoomer.anim.done then
            if sssx then self:teleportPlayer(sssx,sssy) end
                if self.zoomer.onFiunish then
                    self.zoomer:onFinish(self.zoomer)
                end
                self.zoomer.anim = nil
                self.zoomer = nil
            end
        end
            
        if isDown("y") then
            self.colorTiles = {}
    
            if isDown("down") then
                self.camera:setFollowStyle("NO_DEADZONE")
                self:scaleMap(0.5)--zoomIn(0.5,18,3,function() self:loadBattle() end)
            
            elseif isDown("up") then
                self.camera:setFollowStyle("NO_DEADZONE")
                self:scaleMap(2)--zoomIn(2,18,3,function() self:loadBattle() end)
            
            elseif isDown("a") then
                self.camera:setFollowStyle("NO_DEADZONE")
                self:zoomIn(4,18,3,function() self:loadBattle() end)
              --    self:teleportPlayer(sssx,sssy)
            end
        end
    
        if isDown("x") and isDown("bk") then
            local xx,yy = math.random(-100,700),math.random(-100,7)
            local Sx,Sy = 4-- math.random(1,4)
            self:movePlayerToTile(xx,yy)
            if not sssx then
                sssx,sssy=self:getScaledPos(xx,yy,Sx,Sy)
            end
           -- log("scaled value of "..xx..", "..yy.." to "..Sx..": "..sx..", "..sy)
            if isDown("left") then
                m=self:makeBabyMap()
                m:load()
                Gamestate.switch(m)
            elseif isDown("up") then
                local sc=2
                self.camera.scale = self.camera.scale *sc
            elseif isDown("down") then
                local sc=.5
                self.camera.scale = self.camera.scale *sc
            else
             --   self:getLandArea(self.camp.tile.ttx,self.camp.tile.tty)
                --self.camp:zoomIn()--loadCamp()
            end
        end
    
        if isDown("b") then
            if isDown("up") then
                game:reset()
        
            --elf:reset(false)
            elseif isDown("x") then
                self.worldSize.w = self.worldSize.w/2
                self.worldSize.h = self.worldSize.h/2
            else
                self:getLandLength(self.camp.tile.ttx,self.camp.tile.tty,"isWater")
                --[[zz={zx=1,zy=1,x=0,y=0}
                self.worldSize.w = self.worldSize.w*15
                self.worldSize.h = self.worldSize.h*15
                zz.x = self.camp.tile.ttx*14
                zz.y = self.camp.tile.tty*14]]
            end
           -- self:loadChunks()
        end
    
        local ttt=nil
        if isDown("a") and not _loaded and not self.battleLoaded then
            if isDown("b") then love.load() end
            --[[log(saveTable(self))
        
            error("Done!")]]
            self:loadBattle()
        end
    
        local o = self.offset
        local function campRm() self.camp.animation = nil end
        
        if isDown("down") then
            self.camp._y = self.camp.y + speed
            self.offset._y = self.offset._y + speed
        elseif isDown("up") then
            self.camp._y = self.camp.y - speed
            self.offset._y = self.offset._y - speed
        elseif isDown("left") then
            self.camp._x = self.camp.x - speed
            self.offset._x = self.offset._x - speed
        elseif isDown("right") or moveRight then
            self.camp._x = self.camp.x + speed
            self.offset._x = self.offset._x + speed
        end
        self.camp._y = self.camp._y or self.camp.y
        self.camp._x = self.camp._x or self.camp.x
        if self.camp._x ~= self.camp.x or self.camp._y ~= self.camp.y then
            self.camp.animation = Animation:new({
                x=self.camp._x,y=self.camp._y,d=playerSpeed
            })
            self.camp.animation:onComplete(campRm)
            self.camp.animation:start(self.camp)
        end
    --around top: if not self.camp.anim then ...
    end
    
    
    if self.camp.tile then assert(not self.camp.tile.fromBattleScene) end
    
    local o = self.offset
    if self.offset._x > (self.chunk.width)*(self.tile.w) then --+self.offset.x) then
        self.offset._x = 16
        self.offset.x = self.offset.x + 1
        local a = self.allCurrentChunks.x
        local aa = {}
        for c,i in lume.iter(a) do
            aa[c] = i+1
        end
        self.allCurrentChunks.x = aa
        
    elseif self.offset._x <= 0 then--self.chunk.width*self.tile.w*-1 then
        self.offset._x = 16*self.chunk.width
        self.offset.x = self.offset.x - 1
        local a = self.allCurrentChunks.x
        local aa = {}
        for c,i in lume.iter(a) do
            aa[c] = i-1
        end
        self.allCurrentChunks.x = aa
    end
    if self.offset._y > self.chunk.height*self.tile.h then
        self.offset._y = 16
        self.offset.y = self.offset.y + 1
        local a = self.allCurrentChunks.y
        local aa = {}
        for c,i in lume.iter(a) do
            aa[c] = i+1
        end
        self.allCurrentChunks.y = aa
        
    elseif self.offset._y <= 0 then--self.chunk.width*self.tile.h*-1 then
        self.offset._y = self.chunk.height*self.tile.h
        self.offset.y = self.offset.y - 1
        local a = self.allCurrentChunks.y
        local aa = {}
        for c,i in lume.iter(a) do
            aa[c] = i-1
        end
        self.allCurrentChunks.y = aa
    end
    local xval, yval
    for _ = 1, #self.allCurrentChunks.x do
        xval = self.allCurrentChunks.x[_]
        --[[if self.allChunks[xval-5] then
            self.allChunks[xval-5] = nil
        end
        if self.allChunks[xval+5] then
            self.allChunks[xval+5] = nil
        end]] 

        for _y = 1, #self.allCurrentChunks.y do
            yval = self.allCurrentChunks.y[_y]
            if not self.allChunks[xval] or not self.allChunks[xval][yval] then
                self:loadChunks({start=xval,en=xval},{start=yval,en=yval})
            end
            local chunk = self.allChunks[xval][yval]
            chunk:update(dt)
        end
    end
    if self.camp.tile then assert(not self.camp.tile.fromBattleScene) end
    if self.camp.noPath then
    self.camp.old.tile = self.camp.tile
    if self.camp.tile then
        self.camp.tile.unit = nil
    end
    
    self.camp.tile = self.allChunks[o.x][o.y]
    local k = self.camp.tile
    k=k.tiles
    
    if self.camp.tile then assert(not self.camp.tile.fromBattleScene) end
    if ttt then return end
    if o._x/self.tile.w > self.chunk.width then

        self.camp.tile = self.camp.old.tile
        self.camp.animation = false
    else
       --Currently it's actually a chunk
        self.camp.tile = self.camp.tile.tiles[o._x/self.tile.w]
        if not self.camp.tile then
      --  log(o)
       -- log(o._x/16)
  
     --   log("end")
        end
        self.camp.tile = self.camp.tile[o._y/self.tile.h]
        if ttet then
            self.camp.tile = ttt
            self.offset._x=ttt.x*ttt.w
            self.offset._y = ttt.y*ttt.h
        end

        if ttt then
            assert(self.camp.tile.chunky==ttt.chunky and self.camp.tile.chunkx==ttt.chunkx)
            assert(self.camp.tile==ttt)
        end
    end end
    
    self.camp.tile.unit = self.camp
    if self.camp.tile then assert(not self.camp.tile.fromBattleScene) end
    --self:colorTile(self.camp.tile,"red")
    
    if self.camp.tile.isCave then
        game:loadDungeon(self.camp,self.camp.tile)
    end
    self.graph:sample(timer.getFPS())
    
    seekNewGlobals(function(n) warn(inspect(n)) end)--?????
    if track then ProFi:stop() ProFi:writeReport("borkmen.txt") error() end
end

function Overworld:makeNeighborRiver(_x,_y)
  --  local ttile = self.worldSize.data[_x][_y]
    local min = nil
    local vars = {}
    local theTile = nil
    function gID(t) return t.ttx..", "..t.tty end
    local data = self.worldSize.data
    local tdata = self.worldSize.tmpData
    local s = self.random
    for _,c in lume.iter({{0,1},{1,0},{-1,0},{0,-1}}) do--rot.DIRS.FOUR) do
        local  x, y = _x+c[1], _y+c[2]
        local tile = data[x] and data[x][y]
        local xx, yy = self:scaleCoords(x,y)
        if not tile then
            tile = {
                height = self:getHeight(xx,yy),
                fake = true,
                ttx = x,
                tty = y
            }
        else
            if tile.isFrom and tile.isFrom.x == _x and tile.isFrom.y == _y then
                return
            end
        end
       -- tile.source = "none.png"
        tile.isFrom = {x=_x,y=_y}
        if tile.ttx == _x and tile.tty == _y then error("..") end
        local val = tile.height.realValue
        if not ddone[gID(tile)] then table.insert(vars,tile) end
        if not min or val < min then
            theTile = tile
            min = val
        end --theTile = tile
    end
    theTile = lume.randomchoice(vars)
    local t = theTile
    if not t  or t == ttile then
        error("River tile not found near ".._x..", ".._y)
    end
    ddone[gID(t)]=2
    
    if theTile.fake then
        if (t.height.name == "DeepWater") then
            return
        end
        tdata[t.ttx] = tdata[t.ttx] or {}
        tdata[t.ttx][t.tty] = {"river"}
        self:makeNeighborRiver(t.ttx,t.tty)
    elseif not t.fake then
        if not t.isRiver and
         (t.height.name == "DeepWater") then
         t.source="none.png"
            return
        end
        --this will go on until a fake tile is reached
        t.height.name = "ShallowWater"
        t.isRiver = true log(t)
        t.source = "player.png"--biomes/"..lume.randomchoice(t.sources).."/"..t.height.name..".png"
        t._w,t._h = resizeImage(game:getSource(t.source),t.w,t.h)
        self:makeNeighborRiver(t.ttx,t.tty)
    end
        
    return theTile
end
        
function Overworld:generateTerrain(x, y, noCreatures)
    --x, y are scaled
    local s = self.random
    local x,y = x,y
    self.tmpY = y
    self.tmpX = x
    local rivers = self.worldSize.tmpData
    x,y = self:scaleCoords(x,y)
    local elevation = self:getHeight(x,y)
    local temperature = self:getTemperature(x,y,{height=elevation})--scale(noise2D(x*F,y*F)*A)
    local moisture = self:getMoisture(x,y,{height=elevation})--
    local chaos = self:getChaos(x,y,{height=elevation})
    local tile = self:getBiome(elevation, temperature, moisture)
    --local river = self:getRiver(x,y)
    tile.w, tile.h = self.tile.w, self.tile.h
    --log(lume.serialiqze(tile))
    
    tile.height = elevation
    tile.moisture = moisture
    tile.temperature = temperature
    tile.temp = tile.temperature
    tile.chaos = chaos
    
    tile.ttx = self.tmpX
    tile.tty = self.tmpY
    tile.id = tile.ttx..", "..tile.tty
    
    if rivers[__x] and rivers[__x][__y] then
        tile.height.name = "ShallowWater"
        tile.isRiver = true
        tile.isFrom = rivers[__x][__y].isFrom
        if rivers[__x][__y].isRiverSource then
            tile.isRiverSource = true
        end
        self:makeNeighborRiver(__x,__y)
    end
    --if river then tile.height.name = "DeepWater" end
    
    tile.source = "none.png"--
    local source = (type(doDebug)=="number" and not tile.isWater and tile.chaos.name) or
     (doDebug and not tile.isWater and "id") or tile.height.name
    tile.source = "biomes/"..lume.randomchoice(tile.sources).."/"..source..".png"
    
    if type(doDebug) == "number" then
        tile.source="biomes/"..source..".png"
    end
    if tile.isRiver then tile.source= "player.png" end
    if tile.isRiverSource then tile.source = "red.png" end
    tile._w,tile._h = resizeImage(game:getSource(tile.source),tile.w,tile.h)
    if not noCreatures then
        self:getCreatureDwellings(tile)
    end
    local rred = game:getColor("blue")
    --assert(#rred==4,lume.serialize(rred))
    rred[4] = 1*(0.5*tile.moisture.realValue)
    assert(#rred==4,lume.serialize(rred))
    self:colorTile(tile,rred)
    if tile then--.isWater then
   self:makeTileDarker(tile) end--colorTile(tile,rred) log(tile.temp.realValue)end
    store(tile)
    return tile
end

function Overworld:getRiver(x,y)
    local n = getNoise(x,y,mapGen.river)
    if n>0.998 then
        return truye
    end
end
    

function Overworld:getHeight(x,y)
    local heights = mapGen.heights
    local height
    local n = getNoise(x,y,heights)
    if not heights.islands then
        n=n/2+.5
    end
   -- n=n*-1
  --  if n>1 then n=0.9 end
    for i = 1,#heights do
        height = heights[i]
        height.pos = i
        local value = height.value
        if type(value) == "table" then
            value = lume.randomchoice(value)
        end
        if n < value then
            local v = lume.copy(height)
            v.realValue = n
            return v
        end
    end
end

--TT applies here --?????
function Overworld:getTemperature(x,y,t)
    local temperatures = mapGen.temperatures
    
    local mapH = self.worldSize.h*100
    local lat = math.abs(self.tmpY)--pp(self.tmPy)/2
    if lat>mapH then
        lat = lat%mapH
        --assert(latmapH,lat)
    end
 --   assert(lat<mapH,lat.."->"..mapH)
    local lat=(lat/mapH)*(TT)--math.pi/2
    local ele = t.height.realValue
    --decreases temp value by increasing latitude
    local tempMultiplier = 9.9
    local tempHeight = 0.1 -- value at which to decrease temp?
    local tempLoss = 0.1 -- value at which temp is lost per step?
    local n --[[= --1   -((lat/(mapH/2))*t.height.realValue)
      ( (
            ( lat/mapH ) * (-tempMultiplier)
        ) -
        (
            (tempHeight) *tempLoss
        )*
        0.1
    )
    local n=n+ 1 -- the base temperature]]
    
    local _n=math.sin(lat)
    n=_n-(t.height.realValue*0.1)
    
    --if n>.6 and n<.8 then n=n-0.3 end
    if n >= 1 or n<0 then
        n=_n--0.1
        if n<-0.3 then
            t.height.name = "DeepWater"
            t.height.realValue = 0.1
        end
    end
  --  local n=math.random(1,10000)/11000
  --  n=n*t.height.realValue
    --[[if __y/self.worldSize.h >= self.worldSize.h then __y = ((__y/self.worldSize.h)%self.worldSize.h)*self.worldSize.h end   if __y == 0 then __y=1 end
    local n = (self.worldSize.h%pp(__y))
    --log("__y"..__y) log(n)
    n= n/self.worldSize.h-- getNoise(x,y,mapGen.temperatures)

    local t = t or {height={}}
    if n>=1 then
        n= 0.89
    elseif n==0/0 then 
        n = 0.2
    end
    --???n=n*t.height.realValue
    if t.height.name == "Grass" then
        n = n-0.1*t.height.realValue
    elseif t.height.name == "Forest" then
        n = n-0.3*t.height.realValue
    elseif t.height.name == "Rock" then
        n = n-0.3*t.height.realValue
    elseif t.height == "Snow" then
        n = n-0.4*t.height.realValue
    end]]
   -- n=getNoise(x,y,mapGen.temperatures)
    local temp
    for i = 1, #temperatures do
        temp = temperatures[i]
        temp.pos = i
        if n < temp.value then
            local v = lume.copy(temp)
            v.realValue = n
            return v
        end
    end
end

function Overworld:getMoisture(x,y,t)
    local moisture = mapGen.moisture
    local _moisture
    
    local n = getNoise(x,y,moisture)--/2+0.5
    local t = t or {height={realValue=1}}
  --  n=n+(0.1*(1-t.height.realValue))

    --[[if t.height.name == "DeepWater" then
        n = n+0.8*t.height.realValue
    elseif t.height.name == "ShallowWater" then
        n = n+0.3*t.height.realValue
    elseif t.height.name == "Sand" then
        n = n+0.1*t.height.realValue
    elseif t.height == "Grass" then
        n = n+0.25*t.height.realValue
    end]]--

    if n >=1 then cwarn() n = 0.99 end
    for i = 1, #moisture do
        _moisture = moisture[i]
        _moisture.pos = i
        if n < _moisture.value then
            local v = lume.copy(_moisture)
            v.realValue = n
            return v
        end
    end
end

function Overworld:getChaos(x,y,t)
    local n = getNoise(x,y,mapGen.chaos)
    --the higher n is the lower the chaos level
    n = (n*1000)
    if n >1000 then warn() n = 1000 end
    
    for i,chaos in ipairs(mapGen.chaos) do
        chaos.pos = i
        if n <= chaos.value then
            local v = lume.copy(chaos)
            v.realValue = n
            return v
        end
    end
end
    
function Overworld:getBiome(elevation, temperature, moisture)
    local ev = elevation.pos
    local temp = temperature.pos
    local m = moisture.pos
    local _biome = self.biomes[m][temp]
    local isWater = nil
    if elevation.name == "DeepWater" or elevation.name == "ShallowWater" then-- and
      ---  moisture.realValue > mapGen.moisture[4].value then
           -- _biome = "Ocean"
           isWater = true
    end


    local biome = Biomes[_biome]
    biome.name = _biome
    local b = lume.copy(biome)
    b["is"..elevation.name] = true
    b.children = {}
    if elevation.name == "Rock" then
        local mount = {source="biomes/mountain.png",
        draw = function(self)
            love.graphics.draw(game:getSource(self.source),
                self.p._x,self.p._y,0,self._w,self._h)
            end,
        update = function(self,dt)
            self._w,self._h = resizeImage(game:getSource(self.source),16,16)
        end
        }
        mount.p=b
        table.insert(b.children,mount)
        elevation.name = "Forest"
        b.isMountain = true
        b.isForest = false
    elseif elevation.name == "Forest" then
        local mount = {source="biomes/tree.png",
        draw = function(self)
            love.graphics.draw(game:getSource(self.source),
                self.p._x,self.p._y,0,self._w,self._h)
            end,
        update = function(self,dt)
            self._w,self._h = resizeImage(game:getSource(self.source),16,16)
        end
        }
        mount.p=b
        table.insert(b.children,mount)
        b.isForest = true
        elevation.name = "Forest"
    end
   -- log(_biome.." moisture: "..m.." temp: "..temp)
    b.isWater = isWater
    return b
end



function Overworld:getTile(x,y,dontDoCreatures)
    local tile = self.tiles[x] and self.tiles[x][y]
    --local xx, yy = self:scaleCoords(x,y)
    if not tile then
        tile = self:generateTerrain(
            x,
            y,
            dontDoCreatures
        )
        self.tiles[x] = self.tiles[x] or {}
        self.tiles[x][y] = tile
        self.worldSize.data = self.tiles--?
    end
    tile.ttx = x
    tile.tty = y
    return tile
end

function Overworld:isTile(x,y)
    return self.tiles[x] and self.tiles[x][y]
end
function Overworld:_getLandArea(x,y,check)
    if self.tmpMax > 50000 then
        return
    end

    log("iter no.:"..self.tmpMax)
    self.tmpMax = self.tmpMax+1
    local ttx, tty, startTile
    local check = check or "isDeepWater"

    if type(x) == "table" then
        startTile = x
        ttx,tty = x.ttx,x.tty
        check = y or check
    elseif type(x) == "number" then
        ttx, tty = x,y
        startTile = self:getTile(x,y)
    end
    local t
    for x,c in lume.iter(getRound(1)) do
        t = self:getTile(ttx+c[1],tty+c[2])
        if not t[check] and not self.tmpData[tostring(t)] then
            self.tmpData[tostring(t)] = true
            self.tmpArea = self.tmpArea+1
            t.continentAreaID = self.tmpID
            self:colorTile(t,"indigo")
            self:_getLandArea(t,check)
        end
    end
end
function Overworld:getLandArea(x,y,check)
    local ttx, tty, startTile
    local check = check or "isDeepWater"
    
    if type(x) == "table" then
        startTile = x
        ttx,tty = x.ttx,x.tty
        check = y or chekc
    elseif type(x) == "number" then
        ttx, tty = x,y
        startTile = self:getTile(x,y)
    end
    if startTile[check] then return end
    
    startTile.continentAreaID = startTile.continentAreaID or lume.uuid()
    self.tmpData = {}
    self.tmpID = startTile.continentAreaID
    self.tmpArea = 0
    self.tmpMax = 0
    local continentID = startTile.continentAreaID
    local _l = self.worldSize.landMasses[continentID]
    if _l then
        return l
    end
    local ox,oy = -1,-1
    local w,h = 0,0
    local done = {x={},y={}}
    local t
    local getTile = function(...) return self:getTile(...) end
    self:_getLandArea(startTile,check)
    self.worldSize.landMasses[continentID] = self.tmpArea
    
    log("Total land area is "..self.tmpArea)
    self.tmpData = {}
    self.tmpArea = 0
    self.tmpID = nil
    
    return self.worldSize.landMasses[continentID]
end

function Overworld:getLandLength(x,y,check)
    local ttx, tty = x,y
    local startTile = self:getTile(x,y)
    startTile.lengthID = startTile.lengthID or lume.uuid()
    local continentID = startTile.lengthID
    local _l = self.worldSize.landMasses[continentID]
    if _l then
        return _l
    end
    local check = check or "isWater"
    local waterR = {x=false,y=false} --Water reached?
    local ox,oy = -1,-1
    local w,h = 0,0
    local done = {x={},y={}}
    local tmpTile
    local yP,yN,xN,xP = 0,0,0,0
    local waterYP,waterYN,waterXP,waterXN
    local getTile = function(...) return self:getTile(...) end
    
    while not waterYP do
        yP = yP+1
        h = h+1
        tmpTile = getTile(ttx,tty+yP)
        waterYP = tmpTile[check]
        if waterYP then
            h = h-1
        else
        --debugging:
            self:colorTile(tmpTile,"yellow")
        end
    end
    
    while not waterYN do
        yN = yN-1
        h = h+1
        tmpTile = getTile(ttx,tty+yN)
        waterYN = tmpTile[check]
        if waterYN then
            h = h-1
        else
        --debugging:
            self:colorTile(tmpTile,"yellow")
        end
    end
    
    while not waterXP do
        xP = xP+1
        w = w+1
        tmpTile = getTile(ttx+xP,tty)
        waterXP = tmpTile[check]
        if waterXP then
            w = w-1
        else
        --debugging:
            self:colorTile(tmpTile,"red")
        end
    end
    
    while not waterXN do
        xN = xN-1
        w = w+1
        tmpTile = getTile(ttx+xN,tty)
        waterXN = tmpTile[check]
        if waterXN then
            w = w-1
        else
        --debugging:
            self:colorTile(tmpTile,"red")
        end
    end
    
    self.worldSize.landMasses[continentID] = {w=w,h=h,w,h}
    log("Land size is "..w..", "..h)
    return self.worldSize.landMasses[continentID]
end

function Overworld:getAroundTile(tile,range,condition,atleast,topology)
    local tiles,t = {}
    local function getRound(tile,r)
        local _tiles = {}
        self._terrainFov._options.topology = topology or 4
        self._terrainFov:compute(tile.ttx,tile.tty,r,function(x,y)
            table.insert(_tiles,{x=x,y=y})
        end)
        return _tiles
    end
    local atleast = atleast or 0
    local tt,pp=1,nil
    local rr = getRound(tile,range) log("8srat")
    while rr[tt] do
        local i = rr[tt]
        tt = tt+1
        t = self:getTile(i.x,i.y,true)
        if condition then
            if t[condition] then
                table.insert(tiles,t)
            end
        else
        
        end
    end

    if #tiles > atleast then assert(#tiles>0)
        return tiles
    end
    
    return false
end

function Overworld:getCreatureDwellings(tile)
    local s,cond = nil,false
    self.tiles[tile.ttx] = self.tiles[tile.ttx] or {}
    self.tiles[tile.ttx][tile.tty] = tile
    
    for id, creature in pairs(allCreatures) do
        if creature.alias then
            s = (type(creature.alias)=="table" and lume.randomchoice(creature.alias))
                or creature.alias
            cond = (type(s)=="string" and (tile.chaos.name == s)) or
                (tile.chaos.value==s)
               
            if not cond then
                goto continue
            end
            
        end
        cond = creature:condition(self,tile)
        if cond then break end
        
        ::continue::
    end
    if not cond then
        return
    end
    tile.creature = cond.id -- log("!!!! at "..tile.id)
end

function Overworld:colorTile(tile,color)
    if tile.tile then error()
        tile = tile.tile
    end
    tile.colored = true
    if tile.y==7 then ggh=the end
    --table.insert(self.colorTiles,{tile,color})
    
    self.colorTiles[tostring(tile)] = color
end

function Overworld:uncolorTile(tile,color)
    if not self.colorTiles then
       -- return
    end
    self.colorTiles[tostring(tile)] = nil
    --[[
    local tmC = {}
    for x,i in ipairs(self.colorTiles) do
        if i[1] ~= tile and ((color and color==i[2]) or not color) then
            table.insert(tmC, i)
            
        end
    end
    self.colorTiles = tmC]]
end

function Overworld:_colorTile(tile,color)
    if not tile then
        return
    end
    
    if type(color) == "string" then
        color = game:getColor(color)
    end
    
    local x, y = tile._x, tile._y
    local _tile = tile--self.map.tiles[tile.gid]
    local w, h = _tile.width, _tile.height 
    local r, g, b, a = love.graphics.getColor()
    love.graphics.setColor(color)
    love.graphics.rectangle("fill",x,y,16,16)--,w,h)
    love.graphics.setColor(r,g,b,a)
end

function Overworld:makeTileDarker(tile)
    self:colorTile(tile,{0.5,0.5,0.5,.51})
end

function Overworld:colorAllTiles(color)
    self.colorTiles = {}
    
    for x,tile in lum.iter(self.allTiles) do 
        self:colorTile(tile,color)
    end
end

function Overworld:textinput(text)
  gooi.textinput(text)
end

function Overworld:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
    p:close()
    love.event.quit()
  end
end

function Overworld:keyreleased(key, scancode)
  gooi.keyreleased(key, scancode)
end

return Overworld