function isWallCallback(x,y)
    if game._dungeon[x] and game.dungeon[x][y] then
        tile = game._dungeon[x][y]
        if tile.type == "wall" then
            return true
        else
            return false
        end
    end
end

function addDoorToMap(x,y)
    tile = game._dungeon[x][y]
    tile.source = "door.png"
    tile.type  = "door"
    tile.isPassable = true
end

function lockRoom(dungeon)
    local corridors = dungeon.source.getCorridors()
end

function addDoors(room,n)
    local n = n or 1
    for g = 1,n do
        room:addDoor(x,y)
    end
end

function addAllDoorsToMap(dungeon)
    for _,t in pairs(dungeon.source:getRooms()) do
        t:getDoors(addDoorToMap)
    end
    --romm:addDoors(isWallCallback)--(x,y,return true?)
end

function getRoomTiles(room)
--check Bottom should actually be top(in kivy coords) else switch
    local spaces = {}
    local dungeon = game._dungeon
    local walls = {}
    top = room:getTop()
    bottom = room:getBottom()
    left = room:getLeft()
    right = room:getRight()
    log("bottom top\n"..bottom..","..top)
    log("left right\n"..left..","..right)
    for t = top,bottom do
        for r = left,right do
            local dung = dungeon[r][t]
            if dung.type == "wall" then
                table.insert(walls,{x=r,y=t,[1]=r,[2]=t})
            else
                table.insert(spaces,{x=r,y=t,[1]=r,[2]=t})
            end
            
            if t==bottom then
                local dung = dungeon[r][t-1]
                if dung.type == "wall" then
                    table.insert(walls,{x=r,y=t-1,[1]=r,[2]=t-1})
                else
                    table.insert(spaces,{x=r,y=t-1,[1]=r,[2]=t-1})
                end
            end
            if t==top then
                local dung = dungeon[r][t+1]
                if dung.type == "wall" then
                    table.insert(walls,{x=r,y=t+1,[1]=r,[2]=t+1})
                else
                    table.insert(spaces,{x=r,y=t+1,[1]=r,[2]=t+1})
                end
                
            end
            if t==left then
                local dung = dungeon[r-1][t]
                if dung.type == "wall" then
                    table.insert(walls,{x=r-1,y=t,[1]=r-1,[2]=t})
                else
                    table.insert(spaces,{x=r-1,y=t,[1]=r-1,[2]=t})
                end
                
            end
            if t==right then
                local dung = dungeon[r+1][t]
                if dung.type == "wall" then
                    table.insert(walls,{x=r+1,y=t,[1]=r+1,[2]=t})
                else
                    table.insert(spaces,{x=r+1,y=t,[1]=r+1,[2]=t})
                end
                
            end
        end
    end
    return {floors=spaces,walls=walls}
end

function getNonPlayerRoom()

    local _repeat = true
    repeat
        _repeat = false
        local r = getRandomRoom(game._dungeon)
        check = getRoomTiles(r)
        for _,x in ipairs(check.floors) do
            if game._dungeon[x.x][x.y].creatures["player"] then
                _repeat = true
                break
            end
        end
    until not _repeat
    return check
end

function getRandomRoom(dungeon,rooms)
    if not rooms then
        r = dungeon.source:getRooms()
    else
        r = rooms
    end
    rr = lume.randomchoice(r)
    return rr
end

function getRandomSpaceInRoom(dungeon,room)
    local room = room or getRandomRoom(dungeon)
    spaces = getRoomTiles(room)
    return lume.randomchoice(spaces.floors)
end