

--[[function love.update(dt)
world:update(dt)
camera:update(dt)
camera:follow(player.sh:getX(),player.sh:getY())
paddy.update(dt)

	if paddy.isDown("b") then
	    derp.run = 3
	    player.speed = 100
	else
	    derp.run = 2
	    player.speed = 50
	end
	if paddy.isDown("up") then
		player.y = player.y - player.speed  *dt
		player.sh:setLinearVelocity(0,-player.speed)
	--	angle = angle + 10
	--	derp.jump=1
--]]

color = require 'tools/color'


DT = 0
DTmax = .5

local ZoomedCamp = GridMap:extend("ZoomedCamp")


function ZoomedCamp:log(l)
    log(l)
end


function ZoomedCamp:enter()
 --   self:__init__()
end

function ZoomedCamp:update(dt)
    local cameraSpeed = self.cameraSpeed
    local m = {x=self.cameraMan.x,y=self.cameraMan.y}
    self:callSuper("update",dt)
    local trash = self.pop and self.pop:update(dt)
    gooi.update(dt)
    for _,u in lume.iter(self.units) do
        u:update(dt)
    end
    if self:isDown("zoom in") then
        self.camera.scale= self.camera.scale*1.5
        self:rePopUp()
       -- self.cameraSpeed = self.cameraSpeed/1.5
    elseif self:isDown("zoom out") then
        self.camera.scale = self.camera.scale/1.5
        self:rePopUp()
      --  self.cameraSpeed = self.cameraSpeed*1.5
    elseif self:isDown("right") then
        m.x = self.cameraMan.x-self.tileW
        m.moved = true
    elseif self:isDown("left") then
        m.x = self.cameraMan.x+self.tileW
        m.moved = true
    elseif self:isDown("down") then
        m.y = self.cameraMan.y-self.tileH
        m.moved = true
    elseif self:isDown("up") then
        m.y = self.cameraMan.y+self.tileH
        m.moved = true
    end
    self.cameraMan.x = m.x
    self.cameraMan.y = m.y
    if m.moved then
        self:rePopUp()
    end
    if m.momved then--not self.cameraMan.animation and m.moved then
        self.cameraMan.animation = Animuation:new({x=m.x,y=m.y,d=cameraSpeed})
        self.cameraMan.animation:start(self.cameraMan)
        self.cameraMan.animation:update(dt)

    end
    local maxZoom = 10
    local minZoom = 0.05
    if self.camera.scale >  maxZoom then
        self.camera.scale = maxZoom-1
        self.cameraMan.animation= nil
    elseif self.camera.scale < minZoom then
        self.camera.scale = minZoom+0.01
    end
        
end
--[[
    y
x       b
    a
]]
function ZoomedCamp:__init__(kwargs)
    local kwargs = kwargs or {}
    self.super.__init__(self,kwargs)
    self.cameraSpeed = 0.02
    self.usePaddy = true
    self.set = self.paddy.setButtonText
    local set = function(...) return self.paddy:setButtonText(...) end
    self.set = set
    set("a","menu")
    set("x","zoom out")
    set("y","zoom in")
    set("b","send out")

    self.units = kwargs.units or {}

    self.colorTiles = {}
    self.scolorTiles = {}
    
    if kwargs.load then
        self:placeUnits()
    end
    
    self.camera.scale = 1.5
    
end


function ZoomedCamp:placeUnits()
    row = 0
    col = 1
    
    local spaces = {}
    for xs = 1,self.map.width do
        for ys=1,self.map.height do
            if not self.grid[xs][ys].isWater then
                table.insert(spaces,{xs,ys})
            end
        end
    end
    if #spaces == 0 or #spaces<#self.units then
        return
    end
    for _,xx in lume.iter(self.units) do
    
        local coll = lume.randomchoice(spaces)
        local col, row = coll[1],coll[2]
        lume.remove(spaces,coll)
        tile = self.grid[col] and self.grid[col][row]
        assert(self.grid[col],"Tile is not gotten at col "..col)
        assert(tile,"Tile is not gotten at row "..row)
        if tile then
            self:placeUnit(xx,tile)
        end
    end
    local s = math.floor(#self.grid/2)
    local ss = math.floor(#self.grid[math.floor(#self.grid/2)]/2)
    local t = self.grid[s][ss]
    self.cameraMan = {x=t._x,y=t._y}
    return true
end

function ZoomedCamp:placeUnit(unit, tile)
    local _tile = self.map.tiles[tile.gid]
    unit.x = tile._x
    unit.y = tile._y
    unit.w = _tile.w
    unit.h = _tile.h

    unit.tile = tile
    unit.map = self
    tile.unit = unit
end

function ZoomedCamp:scolorTile(tile,color)
    table.insert(self.scolorTiles,{tile,color})
end

function ZoomedCamp:draw()
    self:callSuper("draw")
    self.camera:attach()
   --[[ grid = lume.copy(self.grid)
    table.insert(grid,self.grid[0])
    for x,jc in ipairs(grid) do 
        _jc = lume.copy(jc)
        table.insert(_jc,grid[x][0])
        for u,c in ipairs(_jc) do
            color = "green"
            if c.unit then
                color = "blue" 
                if c.unit.isEnemy then 
                    color = "red" 
                end
                if not c.oldUnit then 
                    color = "cyan"
                end
                c.oldU = 1
            else
                c.oldU = nil
            end
            love.graphics.setColor(game:getColor(color))
            love.graphics.rectangle("fill",c._x,c._y,16,16)
            love.graphics.setColor(1,1,0)
            l,k = self.map:convertPixelToTile(c.x,c.y)
            love.graphics.setColor(game:getColor("black"))
            love.graphics.print(l..", "..k,c._x,c._y,0.25,0.25)
            love.graphics.setColor(1,1,0)
        end
    end]]--
    for nx,i in lume.iter(self.colorTiles) do
      --  self:_colorTile(i[1],i[2])
    end
    for _,u in lume.iter(self.units) do
        u:draw()
    end
    for nx,i in lume.iter(self.scolorTiles) do
        --self:_colorTile(i[1],i[2])
    end
    
    self.camera:detach()
 
    gooi.draw()
    local trash = self.pop and self.pop:draw()
    if sprint then
        love.graphics.print(sprint,W()/2,100) 
    end
    love.graphics.print(sprint2 or "",W()/2,200)
    love.graphics.print((sprint3 or ""),W()/2,50,0,1.4,1.4)
  --  self.camera:attach()
    --self.camera:detach()
    
    self.camera:draw()
end

function ZoomedCamp:mousereleased(x, y, button)
    local trash = self.pop and self.pop:mousereleased(x,y,button)
    gooi.released()
end

function ZoomedCamp:mousepressed(x, y, button)
    local trash = self.pop and self.pop:mousepressed(x,y,button)
    gooi.pressed()
end

function ZoomedCamp:touchreleased(id, x, y, dx, dy, pressure)
    local trash = self.pop and self.pop:touchreleased(id,x,y,dx,dy,pressure)
    if trash then
        self.buttonPressed = true
    end
    if not self.buttonPressed then
        ttx = x
        tty = y
    else
        self.buttonPressed = false
        return
    end
    x,y = self.camera:toWorldCoords(x,y)
   
    local tile = self:getTileWithPos(x,y)
    local sx,sy = self.map:convertPixelToTile(x,y)
    sx = math.floor(sx)
    sy = math.floor(sy) 
   sprint2 = sx..", "..sy
    if tile then
        local now = nil
       -- table.insert(self.colorTiles,{tile,"red"})
      -- self:colorTile(tile,"red")
       sprint2 = sprint2.."yah"
   --     self.cameraMan = {x=x,y=y}
   
        local target = tile.unit
        self.tmpselected = target
        local unit = self.player.selected
        if tile.unit then
            self.tmpselected = tile.unit
            self:popUp(1,tile.unit)
        end
    end
end

function ZoomedCamp:popUp(num, obj)
    self._popUp = {num,obj}
    if self.pop then
        self.pop:destroy()
    end
    log(obj.x..", "..obj.y)
    local sw = 8
    local sh = 2
    local xx, yy = self.camera:toCameraCoords(obj.x,obj.y)
    log(xx..",, "..yy)
   -- local yy= 16--00--yy-100
    yy = yy-(obj.h*5)
    if num==1 then
        local pop = PopUp:new({
            x=xx,
            y=yy,
            w=obj.w*sw,
            h=obj.h*sh,
            data={"EQUIP","FEED","ITEMS"},
            onRelease=function(t)
                if t=="ITEMS" then
                    self.pop:destroy()
                    self:popUp(3,obj)
                elseif t=="EQUIP" then
                    self.pop:destroy()
                    self:popUp(2,obj)
                elseif t=="FEED" then
                    self.pop:destroy()
                    self:popUp(2,obj)
                    
                end
            end
        })
        self.pop = pop
    elseif num==2 then
        local data = player.itemTypes
        local i = obj.inventory
        
        for name, list in ipairs({}) do--player:iterInventory() do
            if ALL_ITEMS[name].isEdible then
                table.insert(data,name)
            end
        end
        table.sort(data, function(a, b) return i[a] end)
        
        local pop = GiverTaker:new({
            data = data,
            x=xx,
            y=yy,
            w=obj.w*sw+20,
            h=obj.h*sh+20,
            inventory = obj.inventory,
            onRelease = function(val,t)
                local lim = player.heldItems[t]
                if val<0 then
                    if self.dont then
                        self.dont = nil
                        return
                    end
                    player:removeItemFromUnit(t,obj)
                elseif val>0 then
                    if lim >= #player.inventory[t] then
                        self.pop.dont = true
                        self.pop.spinner:changeValue(val*-1)
                        return false
                    end
                    player:addItemToUnit(t,obj)
                end
             --   self.pop:destroy()
               -- self:popUp(2,obj)
            end
        })
        self.pop = pop
    end
end

function ZoomedCamp:rePopUp()
    self.camera:update(0.1)
    if not self.pop then
        return
    end
    self.pop:destroy()
    self:popUp(self._popUp[1],self._popUp[2])
end

function ZoomedCamp:textinput(text)
  gooi.textinput(text)
end

function ZoomedCamp:keypressed(key, scancode, isrepeat)
  gooi.keypressed(key, scancode, isrepeat)
  if key == "escape" then
    p:close()
    love.event.quit()
  end
end

function ZoomedCamp:keyreleased(key, scancode) log(key) log("kr")
  gooi.keyreleased(key, scancode)
end

return ZoomedCamp