local Menu = class:extend("Menu")

function Menu:__init__(kwargs)
    self.listbox = lume.copy(listbox)
    
    self.listbox:init()
    self.data = kwargs.data or {}
    self.group = kwargs.group
    
    self.info = gooi.newLabel({
        x=(kwargs.x or 0)+(( kwargs.w or 100)/-19),
        y=kwargs.y or 0,
        h=(kwargs.h or 100),-- kwargs.h/5) or 10,
        w=((kwargs.w or 100)/5)*4,
        min=0,
        max=10,
        text="The true face of the elven\npeople shall be revealed\nin year 3.",
        value=7,
        group=self.group
    }):left ()

    self._data = {
        x = kwargs.x or 0,
        y = (kwargs.y or 0),
        w =( kwargs.w or 100)/5,
        h = kwargs.h or 100,
        istouch = true,
        visible = true,
        incenter = false,
        enabled = true,
        selectedcolor = game:getColor("green"),
        fsize = 30,
        asize = false,--fit box to sizee
        --expand=true,expmode="size",
    }
    
    
    self.listbox:newprop(self._data)
    
    self.add=function(...) self.listbox:additem(...) end
    
    for info,n in lume.iter(self.data) do
        self.add(info,lume.wordwrap(n,50))
    end
    self.listbox:setselected(1)
    self.info:setText(self:getSelectedData())
    self.oldSelected = self:getSelectedText()
    self:create()
    --self.listbox:autosize()
    
end

function Menu:draw()
    self.listbox:draw()
    gooi.draw(self.group)
end

function Menu:destroy()
    self.listbox:setenabled(false)
    self.listbox:setvisible(false)
    gooi.removeComponent(self.info)
end

function Menu:create()
    gooi.removeComponent(self.info)
    self.listbox:setenabled(true)
    self.listbox:setvisible(true)
    gooi.addComponent(self.info)
end

function Menu:getSelectedText()
    return self.listbox:gettext(self.listbox:getselected())
end

function Menu:getSelectedData()
    return self.listbox:getdata(self.listbox:getselected())
end


function Menu:update(dt)
    self.listbox:update(dt)
    local t = self:getSelectedData()
    if t ~= self.oldSelected then
        self.oldSelected = t
        self.info:setText(t)
    end
    --gooi.update(dt)
end

function Menu:mousepressed(x,y,button)
    gooi.pressed()
end

function Menu:mousereleased(x,y,button)
    gooi.released()
end

function Menu:touchpressed(id, x, y, dx, dy, pressure)
    self.listbox:press(x,y)
end

function Menu:touchreleased(id, x, y, dx, dy, pressure)
    self.listbox:released(x,y)
end

return Menu