local PopUp = class:extend("PopUp")

function PopUp:__init__(kwargs)
    local kwargs = kwargs or {}
    local len = kwargs.data and #kwargs.data
    self.listbox = lume.copy(listbox)
    self.gooi = kwargs.gooi
    
    self.listbox:init()
    
    self.button = gooi.newButton({
        x=kwargs.x or 0,
        y=kwargs.y or 0,
        h=(kwargs.h)-kwargs.h/(len+1),--and kwargs.h/5) or 10,
        w=kwargs.w or 100
    }):onRelease(function(r)
        local t = self:getSelectedText()
        local none = kwargs.onRelease and kwargs.onRelease(t)
    end
    )
    self._data = {
        x = kwargs.x or 0,
        y = (kwargs.y or 0)+self.button.h,
        w = (kwargs.w or 100),
        h = (kwargs.h or 100),
        istouch = true,
        visible = true,
        incenter = false,
        enabled = true,
        selectedcolor = game:getColor("red")
    }
    self._data.h = 16--self._data.h - self._data.h/(len+1)
   -- self._data.h = self._data.h/2
    self.listbox:newprop(self._data)
    self.add = function(...) self.listbox:additem(...) end
    for _,x in ipairs(kwargs.data or {}) do
        self.add(x,_)
    end
    self.listbox:setselected(1)
    if kwargs.data then
        self.button:setText(kwargs.data[1])
    end
    self:create()

end

function PopUp:destroy()
    self.listbox:setenabled(false)
    self.listbox:setvisible(false)
    local gooi = self.gooi or gooi
    gooi.removeComponent(self.button)
end

function PopUp:create()
    gooi.removeComponent(self.button)
    self.listbox:setenabled(true)
    self.listbox:setvisible(true)
    gooi.addComponent(self.button)
end

function PopUp:getSelectedText()
    return self.listbox:gettext(self.listbox:getselected())
end

function PopUp:getSelectedDataText()
    return self.listbox:getdata(self.listbox:getselected())
end

function PopUp:draw()
    self.listbox:draw()
  --  gooi.draw()
    local trash = self.gooi and self.gooi.draw()
end

function PopUp:update(dt)

    self.listbox:update(dt)
    local trash = self.gooi and self.gooi.update(dt)
    self.button:setText(self:getSelectedText())

end

function PopUp:mousepressed(x,y,button)
    local trash = self.gooi and self.gooi.pressed()
end

function PopUp:mousereleased(x,y,button)
    local trash = self.gooi and self.gooi.released()
end

function PopUp:touchpressed(id, x, y, dx, dy, pressure)

    self.listbox:press(x,y)
    if (x>self.listbox.x and x<self.listbox.x+self.listbox.w) and (y>self.listbox.y and y<self.listbox.y+self.listbox.h) then
        return true
    end
    

end

function PopUp:touchreleased(id, x, y, dx, dy, pressure)

    self.listbox:released(x,y)
    if (x>self.listbox.x and x<self.listbox.x+self.listbox.w) and (y>self.listbox.y and y<self.listbox.y+self.listbox.h) then
        return true
    end

end

return PopUp