local mapGen = {
    heights = {
        islands=true,
        {--use for not islands:
            --n=(n-0.)×2
            
            name = "DeepWater",
            value = 0.2--3
        },
        {
            name = "ShallowWater",
            value =0.3--4
        },
        {
            name = "Sand",
            value =0.5,
        },
        {
            name = "Grass",
            value = 0.7,
        },
        {
            name = "Forest",
            value = 0.8,
        },
        {
            name = "Rock",
            value = 0.9
        },
        {
            name = "Snow",
            value = 1
        },
        frequency = 1,--.25,
        octaves = 4,
        persistence = .35,
        power = 1,
        
        
    },
    temperatures = {
        {
            name = "Coldest",
            value = 0.05,
        },
        {
            name = "Colder",
            value = 0.18,
        },
        {
            name = "Cold",
            value = 0.4
        },
        {
            name = "Warm",
            value = 0.6
        },
        {
            name = "Warmer",
            value = 0.8
        },
        {
            name = "Warmest",
            value = 1
        },
        frequency = .03,
        octaves = 4,
        power=2
            
    },
    moisture = {
        {
            name = "Dryest",
            value = 0.17
        },
        {
            name = "Dryer",
            value = 0.24
        },
        {
            name = "Dry",
            value = 0.4
        },
        {
            name = "Wet",
            value = 0.6
        },
        {
            name = "Wetter",
            value = 0.8
        },
        {
            name = "Wettest",
            value = 1--0.9
        },
        frequency = .2,--0001,--2,
        octaves = 8,
        persistence = .32,--8,--1.33,
        power = 1,--10,
        amplitude = 1,--3,--11
        scale = function(n) return n end,
        
        
    },
    chaos = {
        {
            name = "Just",
            value = 200
        },
        {
            name = "Equinoxed",
            value = 500
        },
        {
            name = "Vile",
            value = 800
        },
        {
            name = "Venomous",
            value = 900
        },
        {
            name = "Chaotic",
            value = 950
        },
        {
            name = "Nightmarish",
            value = 1000
        },
        
        frequency = .5,--1,
        amplitude = 1,
        power = 4,
        --for higher difficulty (nightmare mode) octaves = 2
        scale = function(n) return n/2+.5 end,
        
    },
        
    river = {
        frequency = 1,
        octaves = 2
    },
    tree = {
        frequency = 60,
        octaves = 1,--?
        scale = function(n) return n/2+.5 end,
    },
    biomes = {
    --Biomes are:
        --Ice
        --Tundra
        --GrassLand
        --Taiga
        --Woodland
        --Desert
        --SeasonalForest
        --TropicalRainForest
        --Savanna

                    --   coldest     colder     cold          hot                   hotter                 hottest
    --[[dryest ]]     {"Ice",      "Tundra",  "Grassland",  "Grassland",             "Desert",              "Desert"},
    --[[dryer  ]]     {"Ice",      "Tundra",  "Grassland",  "Savanna",             "TropicalRainForest",              "Savanna"},
    --[[dry    ]]     {"Ice",      "Tundra",  "Woodland",   "Woodland",           "Savanna",             "Savanna"},
    --[[wet    ]]     {"Ice",      "Tundra",  "Taiga",      "Woodland",           "Woodland",             "Savanna"},
    --[[wetter ]]     {"Ice",      "Tundra",  "Taiga",      "SeasonalForest",     "TropicalRainForest",  "TropicalRainForest"},
    --[[wettest]]     {"Ice",      "Tundra",  "Taiga",      "TropicalRainForest", "TropicalRainForest",  "TropicalRainForest"}
    
    }
}
mm=mapGen.moisture
ch=mapGen.chaos
function amp(n) mm.amplitude=n end
function fre(n) mm.frequency=n end
function per(n) mm.persistence=n end
function pow(n) mm.power=n end

return mapGen