Player = class:extend("Player")

function Player:__init__()
    self.inventory = {
    } --dict of list items
    
    self.units = {
        borkman = {},
        borkman_mystic = {},
        borkman_ranger = {},
        borkman_warrior = {},
        borkman_archer = {},
        borkman_tamer = {},
        borkman_builder = {}
    } --dict of list units
    
    self.itemTypes = {}
    self.heldItems = {}
    self.maxItems = 25
    self.itemCount = 0
    self.id = lume.uuid()
    
    self.x = 0
    self.y = 0
    self._y = 0
    self._x = 0
   -- self.source = game:getSource("player.png")
    self.w = 16
    self.h = 16
    self._w = 0
    self._h = 0
    self.animation = nil
    self.old = {x=0,y=0}
end

function Player:update(dt)
end

function Player:addItemToUnit(item,unit)
    return unit:addItem(item)
end

function Player:removeItemFromUnit(item,obj)
    return obj:removeItem(item)
end

function Player:addItemToInventory(item,obj,obj2)

    if obj then
        if type(obj) == "table" then
            return self:addItemToUnit(item,obj)
        elseif type(obj) == "number" then
            local r = 0
            for x=1,obj do
                self:addItemToInventory(item,obj2)
            end
            return r
        end
    end
    
    local i = self.inventory
    if type(item) == "string" then
        item = ALL_ITEMS[item]
    end
    if #self.itemTypes >= self.maxItems then
        return false
    end
    self.heldItems[item.name] = self.heldItems[item.name] or 0
    
    i[item.name] = i[item.name] or (table.insert(self.itemTypes,item.name)) or {}
    if #i[item.name] > item.maxCount then
        return false
    end
    
    local it = item:new()
    
    it.__id = self.id
    table.insert(i[item.name],it)
    self.itemCount = self.itemCount+1
    return true
end

function Player:removeItemFromInventory(item,obj,obj2)
    
    if obj then
        if type(obj) == "table" then
            return self:removeItemFromUnit(item,obj)
        elseif type(obj) == "number" then
            local r = 0
            for x=1,obj do
                self:removeItemFromInventory(item,obj2)
            end
            return r
        end
    end
        
    local i = self.inventory
    local n = item
    
    if type(item) == "string" then
        if i[n] == nil then
            return false
        end
        if #i[n] == 0 then
            lume.remove(self.itemTypes,n)
            i[n] = nil
            return false
        end
        table.remove(i[n],1)
        if #i[n] == 0 then
            lume.remove(self.itemTypes,n)
            i[n] = nil
        end
        self.itemCount = self.itemCount-1
        return true
        
    else
        if n.__id then
            if i[n.name] == nil then
                return false
            end
            if #i[n.name] == 0 then
                lume.remove(self.itemTypes,n)
                i[n.name] = nil
                return false
            end
            lume.remove(i[n.name],n)
            if #i[n.name] == 0 then
                lume.remove(self.itemTypes,n.name)
                i[n.name] = nil
            end
            self.itemCount = self.itemCount-1
            return true
        end
    end
    return false
end

function Player:removeItem(...)
    return self:removeItemFromInventory(...)
end

function Player:addItem(...)
    return self:addItemToInventory(...)
end



function Player:iterInventory()
    local count = 0
    local tmpIn = lume.copy(self.inventory)
    return function()
       count = count or 0
       for name, list in pairs(tmpIn) do
           for n, item in ipairs(list) do
                count = count+n
                return count, item
            end
            tmpIn[name] = nil
        end
        return nil
    end
end

return Player