local _Tree = class:extend("Tree")

function _Tree:__init__(kwargs)
    local kwargs = kwargs or {}
    self.source = "tree.png"
    self.w = kwargs.w or kwargs.width or 16
    self.h = kwargs.h or kwargs.height or 16
    self._w = 0
    self._h = 0
    self.x = kwargs.x or 0
    self.y = kwargs.y or 0
end

function _Tree:update(dt)
    self._w,self._h = resizeImage(game:getSource(self.source),self.w,self.h)
end

function _Tree:draw()
    love.graphics.draw(game:getSource(self.source),self.x,self.y
    ,0,
    self._w,self._h)
end

Biomes = {
    --tree : the value to be less than for a tree to appear
    Ice = {
        sources = {"ice"},
        life = 3,
        vegetation = 3
    },
    Tundra = {
        sources = {"tundra"},
        life = 3,
        vegetation = 3
    },
    Grassland = {
        sources = {"grassland"},
        life = 3,
        vegetation = 9
    },
    Woodland = {
        sources = {"woodland"},
        life = 3,
        vegetation = 8
    },
    Taiga = {
        sources = {"taiga"},
        life = 3,
        vegetation = 3
    },
    SeasonalForest = {
        sources = {"seasonal_forest"},
        life = 3,
        vegetation = 3
    },
    TropicalRainForest = {
        sources = {"tropical_rain_forest"},
        life = 3,
        vegetation = 7
    },
    Savanna = {
        sources = {"savanna"},
        life = 3,
        vegetation = 3
    },
    Desert = {
        sources = {"desert"},
        life = 3,
        vegetation = 3
    },
    Ocean = {
        sources = {"water"},
        life = 3,
        vegetation = 3
    },
    Tree = _Tree
}

return Biomes