local BaseClass = {}
CLASSES = {BaseClase=BaseClass}

function BaseClass:new(...)
    local t = setmetatable({}, self)
    t:__init__(...) 
    local kw = ...
    t._kwargs = t._kwargs or t.kwargs or (kw and type(kw)=="table" and kw)
    return t
end

function BaseClass:extend(name, t)
    t = t or {}
    t.__index = t
    t.__class = name
    t.super = self
    local tclass = setmetatable(t, { __call = self.new, __index = self })
    CLASSES[name] = tclass
    return tclass
end

function BaseClass:__init__()
end

function BaseClass:callSuper(func,...)
    if not self.super[func] then
        return
    end
    return self.super[func](self,...)
end

return BaseClass

