local World = require("tools/GOAPlua/World")
local Planner = require("tools/GOAPlua/Planner")
local ActionList = require("tools/GOAPlua/Action")

local ACTION={
     cost=0,
     actions=0,
     set_states={},
     preconditions={},
     _type="action",
}

goap = {
    Action = ActionList,
    ActionList = ActionList,
    Planner = Planner,
    World = World
}

local function getKeys(t)
    tt = {}
    for i,o in pairs(t) do
        table.insert(tt,i)
    end
    
    return tt
end

goap.get_action_plan = function(item, all_actions, wanted_state)
        --[[
        {
            name = "goblin"
            states/world = {
                hasJar = false,
                hungry = true
            },
        }
        ]]
        
        local actions = {}
        local world  = item.states or item.states
        p = Planner.new(getKeys(world))
        p.set_start_state(world)
        p.set_goal_state(wanted_state)
        al = ActionList.new()
        
        for x,act in pairs(all_actions) do
           
            if x == "name" then
                goto continue
            end
           
            act.name = x
            item._current_action = act
            
            if act.action then
                act.actions = act.action
            end
            
            for _,i in pairs(ACTION) do
                act[_] = act[_] or i
            end
            
            al:add_condition(x, act.preconditions)
            al:add_reaction(x ,act.set_states)
            
            if act.cost_cal then
                --self.decode_command(item,act.cost_cal)
            end
            
            al:set_weight(x, act.cost)
            ::continue::
        end
        
        p:set_action_list(al)
        path = p:calculate()
        
        for _p in lume.iter(path) do
            table.insert(actions,_p.name)--all_actions[_p.name])
        end
        
        return actions
end

goap.get_plan_for_item = function(self, item, states)
        local doc = "use: get_plan_for_item( table item , table wanted_states ) "
        if not states.global then
            all_actions = item.actions
        else
            --all_actions = global actions?
        end
        
        local plan = goap.get_action_plan(item,all_actions,states)
        
        local x = plan[1]
        item["current_plan"] = plan
        item["current_plan_number"] = 1
        
        if item["automatic_states"] then
            for s,ss in pairs(x["set_states"]) do
                item.states[s] = ss
            end
        end
        return x
end

return goap