class = require "class"
lume = require "lume"
require "tools"

require "animation"
Sprite = class:extend("Sprite")
    
function toggle(list,current)
    f = lume.find(list,current)
    if f then
        if list[f+1] then
            return list[f+1]
        else
            return list[1]
        end
    end
end
    
local function swingLeg(arm,dt,self)
    local angle = arm.rot
    local speed = self.angles.speed
    if self.jump then local speed = self.jumpAngles.speed end
    if not arm.check then
        if isLeft then
            arm._check = {135,35}
        else
            arm._check = {35,135}
        end
        arm.check = 55-arm._check[1]
        
    end
    if angle >= arm.check then
        angle = angle - speed*dt
        if self.jump then
            --if I've already jumped..
            if arm.check == self.jumpAngles.max then
                arm.check = self.angles.min
                self.jump = false
            else
                arm.check = self.jumpAngles.min
            end
        else
            arm.check = self.angles.min
        end
        arm.check = -25--toggle(arm._check,arm.check,self)
        log(arm.check..">>")
    elseif  angle <= arm.check then
    
        angle = angle + speed*dt
        if self.jump then
            --if I've already jumped..
            if arm.check == self.jumpAngles.min then
                arm.check = self.angles.max
                self.jump = false
            else
                arm.check = self.jumpAngles.max
            end
        else
            arm.check = self.angles.max
        end
        log(arm.check.."<<")
    end
    log(angle)
    log("lllll")
    if math.floor(angle) == 0 then
        --pause?
    end
    arm.rot = angle
            
end
rots  = {}
for i=-25,56 do
    table.insert(rots,i)
end
local function swingLeftArm(sprite)
    local self = sprite
    local a = self.rightArm.rot
    local d = 55-math.floor(a)
    local p = rots[d]
    if p then log("yayahhh") 
        self.leftArm.rot = p + (1 +(a-math.floor(a)))
    end
end

local function swingLeftLeg(sprite)
    local self = sprite
    local a = self.rightLeg.rot
    local d = 55-math.floor(a)
    local p = rots[d]
    if p then log("yayahhh") 
        self.leftLeg.rot = p + (1 +(a-math.floor(a)))
    end
end

local function swingArm(arm,dt,self)
    local angle = arm.rot
    local speed = self.angles.speed
    if self.jump then local speed = self.jumpAngles.speed end
    if not arm.check then
        if isLeft then
            arm._check = {135,35}
        else
            arm._check = {35,135}
        end
        arm.check = 55-arm._check[1]
        
    end
    if math.floor(angle) == 15 then
        
    arm.swing=true
    end
    if angle >= arm.check then
        angle = angle - speed*dt
        if self.jump then
            --if I've already jumped..
            if arm.check == self.jumpAngles.max then
                arm.check = self.angles.min
                self.jump = false
            else
                arm.check = self.jumpAngles.min
            end
        else
            arm.check = self.angles.min
        end
        arm.check = -25--toggle(arm._check,arm.check)
        log(arm.check..">>")
    elseif  angle <= arm.check then
    
        angle = angle + speed*dt
        if self.jump then
            --if I've already jumped..
            if arm.check == self.jumpAngles.min then
                arm.check = self.angles.max
                self.jump = false
            else
                arm.check = self.jumpAngles.max
            end
        else
            arm.check = self.angles.max
        end
        log(arm.check.."<<")
    end
    log(angle)
    if math.floor(angle) == 0 then
        --pause?
    end
    arm.rot = angle
    
end

function Sprite:__init__(kwargs)

    self.velocity = {x=0,y=0}
    self.angles = {min=-25,max=55,speed=90}
    self.jumpAngles = {min=-50,max=80,speed=180}
    
    self.flipX = 1
    self.flipY = 1
    self.drawingOrder = {
        self.head, self.leftLeg,self.rightArm,self.rightLeg,self.body,self.leftArm
    }

    self.size = kwargs.size or {7,14}
    self.sources = {
		head = "head.png",
		body = "body.png",
		arm = "arm.png",
		leftArm = nil,
		rightArm = nil,
		leg = "leg.png",
		leftLeg = nil,
		rightLeg = nil
	}
	if kwargs.sources then
	    for part, source in pairs(kwargs.sources) do
	        self.sources[part] = source
	    end
    end
	self.proportions = kwargs.proportions or {}
	self.obj = kwargs.obj or {}

    local w,h = self.size[1], self.size[2]
	
	space = {
		w = w*.14286,
		h = h*.03--714
	}
	
	self.head = {
		w = w*.57146,
		h = h*.2857,
		y = 0-(h*.2857/2)-space.h,
		x = (w*.2857)/2,
		source = game:getSource(self.sources.head),
		rot = 0
	}
	self.rightArm = {
		w = w*.2857,
		h = h*.2857,
		x = (w*.57146)/1, --+((w*.2857)/2),
		y = (w*.2857)/1,
		source = game:getSource(self.sources.rightArm or self.sources.arm),
		rot = 0
	}
	self.leftArm = {
		w = w*.2857,
		h = h*.2857,
		x = -(w*.2857)/6,--(w*.2857)),
		y = (w*.2857)/1,
		source = game:getSource(self.sources.leftArm or self.sources.arm),
		rot = 0
	}
	self.rightLeg = {
		w = w*.2857,
		h = h*.2857,
		x = (w*.2857)/2,
		y = (space.h*2)+(h*.2857)+space.h,
		source = game:getSource(self.sources.rightLeg or self.sources.leg),
		rot = 0
	}
	self.leftLeg = {
		w = w*.2857,
		h = h*.2857,
		x = (((w*.2857)/2)+((w*.57146)/2)), 
		y = self.rightLeg.y+space.h,
		source = game:getSource(self.sources.leftLeg or self.sources.leg),
		rot = 0
	}
	self.body = {
		w = w*.57146,
		h = h*.2857,
		x = (w*.2857)/2,
		y = (w*.2857)/1,
		source = game:getSource(self.sources.body),
		rot = 0
	}
	
end

function Sprite:update(dt)
    swingArm(self.rightArm,dt,self)
    swingLeftArm(self,dt)
    swingLeg(self.rightLeg,dt,self)
    swingLeftLeg(self,dt)
    
    if self.velocity.x < 0 then
        self.flipX = -1
        self.drawingOrder = {
            self.head,self.leftArm,self.body,self.rightLeg,self.rightArm,self.leftLeg
         }
    else
        self.flipX = 1
        self.drawingOrder = {
        self.head, self.leftLeg,self.rightArm,self.rightLeg,self.body,self.leftArm
    }

    
    end
end

function Sprite:draw(dt)
	love.graphics.setColor(25,32,0,255)
        self.drawingOrd5er = {
            self.head,self.rightArm,self.body,self.rightLeg,self.leftLeg,self.leftArm
         }
    self.drawingOwrder = {
        self.head, self.leftLeg,self.rightArm,self.rightLeg,self.body,self.leftArm
    }
    
    for _,x in ipairs(self.drawingOrder) do
    
        if not x.sw then
            x.sw,x.sh = resizeImage(x.source,x.w,x.h)
        end
        xw = 0
        if self.flipX < 0 then
            if x==self.head or x == self.body then
                v,vv=x.source:getDimensions()
                xw = 0--((v*x.sw))/2
                xw = self.size[1]*.57146
            else
                v,vv=x.source:getDimensions()
              --  xw = (self.size[1]*(v*x.sw))/2
                self.flipX=1
            end
        end log("sssssssss"..x.sw)
        love.graphics.draw(
            x.source,
            x.x+self.obj.x+xw,
            x.y+self.obj.y,
            math.rad(x.rot),
            x.sw*self.flipX,
            x.sh
        )
    end
	-- Draw the player
	love.graphics.setColor(25,32,0,255)
--	love.graphics.rectangle("fill", player.x,player.y,40,40)
end

return Sprite